// BrowseCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "BrowseCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBrowseCtrl

CBrowseCtrl::CBrowseCtrl()
{
	m_bThreadActive=FALSE;
	m_numcolumns=m_numitems=0;
	m_pCheckSelThread=NULL;
}

CBrowseCtrl::~CBrowseCtrl()
{
	while (m_bThreadActive==TRUE) Sleep(1);
}


BEGIN_MESSAGE_MAP(CBrowseCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CBrowseCtrl)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrowseCtrl message handlers

void CBrowseCtrl::PreSubclassWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	ListView_SetExtendedListViewStyle(m_hWnd,
         /*LVS_EX_CHECKBOXES|*/LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES |
		 LVS_EX_REGIONAL);
	
	CListCtrl::PreSubclassWindow();
	m_pCheckSelThread=AfxBeginThread(CheckSelThread,this);
}

void CBrowseCtrl::AddColumn(CString cs)
{
	LV_COLUMN lvc;
	lvc.mask=LVCF_FMT|LVCF_WIDTH|LVCF_TEXT|LVCF_SUBITEM;
	lvc.fmt=LVCFMT_LEFT;

	lvc.pszText=(char *)(LPCSTR)cs;
	lvc.cx=GetStringWidth(lvc.pszText)+15;
	lvc.iSubItem=m_numcolumns; InsertColumn(m_numcolumns++,&lvc);
}

void CBrowseCtrl::AddItem(int c, CString cs, DWORD dw)
{
	LV_ITEM lv;
	lv.mask=LVIF_TEXT|LVIF_STATE|(c?0:LVIF_PARAM);
	lv.state=0;
	lv.iImage=0; lv.lParam=dw;
	lv.iItem=c?m_numitems-1:m_numitems;

	lv.pszText=(char *)((LPCSTR)cs); lv.iSubItem=c;
	if (c==0) {
		InsertItem(&lv);
		m_numitems++;
	} else {
		SetItem(&lv);
	}
}

int CBrowseCtrl::GetNumItems()
{
	return m_numitems;
}

int CBrowseCtrl::GetNumColumns()
{
	return m_numcolumns;
}

int CBrowseCtrl::GetSelected()
{
	for (int i=0; i<m_numitems; i++)
		if (GetItemState(i) & LVIS_SELECTED) return i;
	return -1;
}

DWORD CBrowseCtrl::GetItemState(int n)
{
	LV_ITEM lv;
	lv.mask=LVIF_STATE;
	lv.stateMask=lv.state=LVIS_SELECTED;
	lv.iImage=0; lv.iItem=n;  lv.iSubItem=0;
	GetItem(&lv);
	return lv.state;
}

DWORD CBrowseCtrl::GetItemData(int n)
{
	LV_ITEM lv;
	lv.mask=LVIF_PARAM;
	lv.state=0;	lv.iImage=0;
	lv.iItem=n;  lv.iSubItem=0;
	GetItem(&lv);

	return lv.lParam;
}

CString CBrowseCtrl::GetItemText(int r, int c)
{
	CString cs; 
	LV_ITEM lv;
	lv.mask=LVIF_TEXT;
	lv.pszText=cs.GetBuffer(CBROWSE_MAXTEXTITEM+1);
	lv.cchTextMax=CBROWSE_MAXTEXTITEM;
	lv.state=0;	lv.iImage=0;
	lv.iItem=r;  lv.iSubItem=c;
	GetItem(&lv);
	cs.ReleaseBuffer();
	return cs;
}

void CBrowseCtrl::DeleteColumn(int n)
{
	if (CListCtrl::DeleteColumn(n)) m_numcolumns--;
}

void CBrowseCtrl::DeleteAllColumns()
{
	for (; m_numcolumns; ) CListCtrl::DeleteColumn(m_numcolumns-1);
}

void CBrowseCtrl::DeleteItem(int n)
{
	int current=GetSelected();
	if (CListCtrl::DeleteItem(n)) {
		m_numitems--;
		if (current>=m_numitems) current=m_numitems-1;
		SelectItem(current);
	}
}

void CBrowseCtrl::SelectItem(int n)
{
	LV_ITEM lv;
	lv.mask=LVIF_STATE;
	lv.stateMask=lv.state=LVIS_SELECTED;
	lv.iImage=0; lv.iItem=n;  lv.iSubItem=0;
	SetItem(&lv);
}

void CBrowseCtrl::DeleteItemToEnd(int n)
{
	int current=GetSelected();
	for (int i=m_numitems-1; i>=n; i--) DeleteItem(i);
	if (m_numitems-1) current=m_numitems-1;
	SelectItem(current);
}

void CBrowseCtrl::DeleteAllItems()
{
	if (CListCtrl::DeleteAllItems()) m_numitems=0;
}

void CBrowseCtrl::SetSelected(int n)
{
	if (n<0) n=0;
	if (n>m_numitems) n=m_numitems-1;
	if (n>=0) {
		SetItemState(n,LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED);
		EnsureVisible(n,TRUE);
	}
}

void CBrowseCtrl::OnSelChange(int n)
{
}

static UINT CheckSelThread(void *p)
{
	CBrowseCtrl &brc=*(CBrowseCtrl *)p;

	int newsel=-1;
	int oldsel=brc.GetSelected();
	HWND hw=brc.m_hWnd;
	brc.m_bThreadActive=TRUE;

	for (;;) {
		if (!IsWindow(hw)) break;
		newsel=brc.GetSelected();
		if (newsel!=oldsel) {
			brc.OnSelChange(newsel);
			oldsel=newsel;
		}
		Sleep(10);
	}
	
	brc.m_bThreadActive=FALSE;
	return 0;
}

int CBrowseCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style|=LVS_SHOWSELALWAYS;
	if (CListCtrl::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	
	return 0;
}

void CBrowseCtrl::OnDestroy()
{
retry_suspend:
	if (m_pCheckSelThread) {
		if (m_pCheckSelThread->SuspendThread()!=(DWORD)-1) ;
		else { Sleep(1); goto retry_suspend; }
	}
}
