// BrowseView.cpp : implementation file
//

#include "stdafx.h"
#include "BrowseView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBrowseView

IMPLEMENT_DYNCREATE(CBrowseView, CListView)

CBrowseView::CBrowseView()
{
	m_numcolumns=m_numitems=0;
	m_notify_flag=FALSE;
}

CBrowseView::~CBrowseView()
{
}


BEGIN_MESSAGE_MAP(CBrowseView, CListView)
	//{{AFX_MSG_MAP(CBrowseView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrowseView drawing

void CBrowseView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CBrowseView diagnostics

#ifdef _DEBUG
void CBrowseView::AssertValid() const
{
	CListView::AssertValid();
}

void CBrowseView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBrowseView message handlers

void CBrowseView::AddColumn(CString cs)
{
	LV_COLUMN lvc;
	lvc.mask=LVCF_FMT|LVCF_WIDTH|LVCF_TEXT|LVCF_SUBITEM;
	lvc.fmt=LVCFMT_LEFT;

	lvc.pszText=(char *)(LPCSTR)cs;
	lvc.cx=GetListCtrl().GetStringWidth(lvc.pszText)+15;
	lvc.iSubItem=m_numcolumns; GetListCtrl().InsertColumn(m_numcolumns++,&lvc);
}

void CBrowseView::AddItem(int c, CString cs, DWORD dw)
{
	LV_ITEM lv;
	lv.mask=LVIF_TEXT|LVIF_STATE|(c?0:LVIF_PARAM);
	lv.state=0;	lv.iImage=0; lv.lParam=dw;
	lv.iItem=c?m_numitems-1:m_numitems;

	lv.pszText=(char *)((LPCSTR)cs); lv.iSubItem=c;
	if (c==0) {
		GetListCtrl().InsertItem(&lv);
		GetListCtrl().EnsureVisible(m_numitems,TRUE);
		m_numitems++;
	} else {
		GetListCtrl().SetItem(&lv);
	}
}

void CBrowseView::DeleteAllColumns()
{
	for (; m_numcolumns; ) DeleteColumn(m_numcolumns-1);
}

void CBrowseView::DeleteAllItems()
{
	if (GetListCtrl().DeleteAllItems()) m_numitems=0;
}

void CBrowseView::DeleteColumn(int n)
{
	if (GetListCtrl().DeleteColumn(n)) m_numcolumns--;
}

void CBrowseView::DeleteItem(int n)
{
	int current=GetSelected();
	if (GetListCtrl().DeleteItem(n)) {
		m_numitems--;
		if (current>=m_numitems) current=m_numitems-1;
		SelectItem(current);
	}
}

void CBrowseView::DeleteItemToEnd(int n)
{
	int current=GetSelected();
	for (int i=m_numitems-1; i>=n; i--) DeleteItem(i);
	if (m_numitems-1) current=m_numitems-1;
	SelectItem(current);
}

DWORD CBrowseView::GetItemData(int n)
{
	LV_ITEM lv;
	lv.mask=LVIF_PARAM;
	lv.state=0;	lv.iImage=0;
	lv.iItem=n;  lv.iSubItem=0;
	GetListCtrl().GetItem(&lv);
	return lv.lParam;
}

DWORD CBrowseView::GetItemState(int n)
{
	LV_ITEM lv;
	lv.mask=LVIF_STATE;
	lv.stateMask=lv.state=LVIS_SELECTED;
	lv.iImage=0; lv.iItem=n;  lv.iSubItem=0;
	GetListCtrl().GetItem(&lv);
	return lv.state;
}

CString CBrowseView::GetItemText(int r, int c)
{
	CString cs; 
	LV_ITEM lv;
	lv.mask=LVIF_TEXT;
	lv.pszText=cs.GetBuffer(CBROWSE_MAXTEXTITEM+1);
	lv.cchTextMax=CBROWSE_MAXTEXTITEM;
	lv.state=0;	lv.iImage=0;
	lv.iItem=r;  lv.iSubItem=c;
	GetListCtrl().GetItem(&lv);
	cs.ReleaseBuffer();
	return cs;
}

int CBrowseView::GetNumColumns()
{
	return m_numcolumns;
}


int CBrowseView::GetSelected()
{
	for (int i=0; i<m_numitems; i++)
		if (GetItemState(i) & LVIS_SELECTED) return i;
	return -1;
}

int CBrowseView::GetNumItems()
{
	return m_numitems;
}

void CBrowseView::SelectItem(int n)
{
	LV_ITEM lv;
	lv.mask=LVIF_STATE;
	lv.stateMask=lv.state=LVIS_SELECTED;
	lv.iImage=0; lv.iItem=n;  lv.iSubItem=0;
	GetListCtrl().SetItem(&lv);
}

BOOL CBrowseView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	dwStyle=WS_VISIBLE|LVS_ALIGNLEFT|LVS_REPORT|LVS_SHOWSELALWAYS|LVS_SINGLESEL;
	
	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CBrowseView::PreSubclassWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CListView::PreSubclassWindow();
}

void CBrowseView::OnInitialUpdate() 
{
	CListView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	ListView_SetExtendedListViewStyle(GetListCtrl().m_hWnd,
         /*LVS_EX_CHECKBOXES|*/LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES | LVS_EX_REGIONAL);
}


void CBrowseView::SetSelected(int n)
{
	if (n<0) n=0;
	if (n>m_numitems) n=m_numitems-1;
	if (n>=0) GetListCtrl().SetItemState(n,
		LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED);
}

BOOL CBrowseView::OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (message==WM_NOTIFY) {
		NMLISTVIEW &nmlv=*(LPNMLISTVIEW)lParam;
		if (nmlv.hdr.code==LVN_ITEMCHANGED) {
			if (nmlv.uNewState==(LVIS_SELECTED|LVIS_FOCUSED)) {
				if (m_notify_flag) {
					OnSelChange(nmlv.iItem);
					m_notify_flag=FALSE;
				} else m_notify_flag=TRUE;
			}
		}
	}
	
	return CListView::OnChildNotify(message, wParam, lParam, pLResult);
}

void CBrowseView::OnSelChange(int n)
{
}
