// ConfPage.cpp : implementation file
//

#include "stdafx.h"
#include "TGW6.h"
#include "ConfPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfPage property page

IMPLEMENT_DYNCREATE(CConfPage, CPropertyPage)

CConfPage::CConfPage() : CPropertyPage(CConfPage::IDD)
{
}

CConfPage::CConfPage(CConfigItem * pCfg) : CPropertyPage(CConfPage::IDD)
{
	//{{AFX_DATA_INIT(CConfPage)
	m_count_in = 0;
	m_count_mail = 0;
	m_count_out = 0;
	m_netstat = "  ";
	//}}AFX_DATA_INIT
	
	m_PropPageTitle=pCfg->m_name;	// temporary storage
	m_psp.pszTitle = m_PropPageTitle;
	m_psp.dwFlags |= PSP_USETITLE;
	m_pCfg=pCfg;
}

CConfPage::~CConfPage()
{
}

void CConfPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfPage)
	DDX_Control(pDX, IDC_PG_ICON, m_pg_icon);
	DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Text(pDX, IDC_COUNT_IN, m_count_in);
	DDX_Text(pDX, IDC_COUNT_MAIL, m_count_mail);
	DDX_Text(pDX, IDC_COUNT_OUT, m_count_out);
	DDX_Text(pDX, IDC_NET, m_netstat);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfPage, CPropertyPage)
	//{{AFX_MSG_MAP(CConfPage)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfPage message handlers

BOOL CConfPage::OnInitDialog() 
{
	m_pCfg->m_pPage=this;
	
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_list.AddColumn("    ");
	m_list.AddColumn("                  "
					 "                                      "
					 "                                      "
					 "                                      ");

	//   
	if (m_pCfg->m_disabled=="1") {
		m_pg_icon.SetIcon(GetApp()->m_Icon_Blue);
		m_pCfg->m_pLoaderThread=AfxBeginThread((AFX_THREADPROC)LoaderThreadProc,(LPVOID)this);
retry_suspend:
		if (m_pCfg->m_pLoaderThread->SuspendThread()!=(DWORD)-1) ;
		else { Sleep(1); goto retry_suspend; }
	} else {
		m_pg_icon.SetIcon(GetApp()->m_Icon_Red);
		m_pCfg->m_pLoaderThread=AfxBeginThread((AFX_THREADPROC)LoaderThreadProc,(LPVOID)this);
	}

	// Create starter thread
	SetTimer(TIMER_INFO_ID,500,NULL);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConfPage::DisplayStatusInfo()
{
	WIN32_FIND_DATA fd;
	HANDLE h;

	if (!m_pCfg) return;

	//     
	m_count_mail=0;
	h=FindFirstFile(GetApp()->GetMailSpoolDir()+"\\*.tmp",&fd);
	if (h!=INVALID_HANDLE_VALUE) {
		m_count_mail++;
		for (; FindNextFile(h,&fd); ) {
			m_count_mail++;
		}
		FindClose(h);
	}

	//     
	m_count_in=0;
	h=FindFirstFile(m_pCfg->m_in_dir+"\\*.in",&fd);
	if (h!=INVALID_HANDLE_VALUE) {
		m_count_in++;
		for (; FindNextFile(h,&fd); ) {
			m_count_in++;
		}
		FindClose(h);
	}

	//     
	m_count_out=0;
	h=FindFirstFile(m_pCfg->m_out_dir+"\\*.out",&fd);
	if (h!=INVALID_HANDLE_VALUE) {
		m_count_out++;
		for (; FindNextFile(h,&fd); ) {
			m_count_out++;
		}
		FindClose(h);
	}

	//     
	if (m_pCfg->m_disabled=="1") {
		m_netstat=" ";
		m_pg_icon.SetIcon(GetApp()->m_Icon_Blue);
	}
	else {
		if (m_pCfg->m_hConfProcess==NULL) {
			m_netstat="  ";
			m_pg_icon.SetIcon(GetApp()->m_Icon_Red);
			m_pCfg->m_stdp_status=CWinSTDP::WinSTDPStatus::CONN_NOT_SET;
		} else {
			switch (m_pCfg->m_stdp_status) {
			case CWinSTDP::WinSTDPStatus::CONN_OK: 
				{
					m_netstat=" ";
					m_pg_icon.SetIcon(GetApp()->m_Icon_Green);
				}
				break;
			case CWinSTDP::WinSTDPStatus::CONN_HIDER_ERR: 
				{
					m_netstat="  STDP";
					m_pg_icon.SetIcon(GetApp()->m_Icon_Red);
				}
				break;
			case CWinSTDP::WinSTDPStatus::CONN_UNK_CLIENT: 
				{
					m_netstat="  ";
					m_pg_icon.SetIcon(GetApp()->m_Icon_Yellow);
				}
				break;
			case CWinSTDP::WinSTDPStatus::CONN_UNK_SERVER: 
				{
					m_netstat="  ";
					m_pg_icon.SetIcon(GetApp()->m_Icon_Yellow);
				}
				break;
			case CWinSTDP::WinSTDPStatus::CONN_REP_CONNECT: 
				{
					m_netstat=" ";
					m_pg_icon.SetIcon(GetApp()->m_Icon_Yellow);
				}
				break;
			case CWinSTDP::WinSTDPStatus::CONN_CHAN_CLOSED: 
				{
					m_netstat="  ";
					m_pg_icon.SetIcon(GetApp()->m_Icon_Red);
				}
				break;
			case CWinSTDP::WinSTDPStatus::CONN_ACCESS: 
				{
					m_netstat="O  ";
					m_pg_icon.SetIcon(GetApp()->m_Icon_Yellow);
				}
				break;
			case CWinSTDP::WinSTDPStatus::CONN_NOT_SET: 
				{
					m_netstat="  ";
					m_pg_icon.SetIcon(GetApp()->m_Icon_Red);
				}
				break;
			case CWinSTDP::WinSTDPStatus::CONN_CORRUPT: 
				{
					m_netstat="  STDP";
					m_pg_icon.SetIcon(GetApp()->m_Icon_Yellow);
				}
				break;
			default: ;
			}
		}
	}

	UpdateData(FALSE);
}

void CConfPage::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent==TIMER_INFO_ID) {
		DisplayStatusInfo();
		SetTimer(nIDEvent,500,NULL);
	}
	
	CPropertyPage::OnTimer(nIDEvent);
}

BOOL CConfPage::OnSetActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	if (m_pCfg->m_disabled=="1") {
		GetDlg()->m_menu.CheckMenuItem(ID_CONF_OFFLINE,MF_CHECKED|MF_BYCOMMAND);
	} else {
		GetDlg()->m_menu.CheckMenuItem(ID_CONF_OFFLINE,MF_UNCHECKED|MF_BYCOMMAND);
	}
	return CPropertyPage::OnSetActive();
}

void CConfPage::WriteLog(LPCSTR fmt, ...)
{
	va_list marker;
	CString cs,time_cs;
	if (m_list.GetNumItems()>100) m_list.DeleteItem(0);
	time_cs=CTime::GetCurrentTime().Format("%H:%M:%S");

	va_start(marker,fmt);
	cs.FormatV(fmt,marker);
	va_end(marker);

	char *p=cs.GetBuffer(1024);
	for (; p[0]; p++) {
		if (p[0]=='\r') p[0]=' ';
		if (p[0]=='\n') p[0]=' ';
		if (p[0]=='\t') p[0]=' ';
	}
	cs.ReleaseBuffer();

	m_list.AddItem(0,time_cs);
	m_list.AddItem(1,cs);

	m_list.SelectItem(m_list.GetNumItems()-1);
	m_list.EnsureVisible(m_list.GetNumItems()-1,TRUE);

	//    log-
	CString fname; fname.Format("\\TGW_%s.log",m_pCfg->m_name);
retry:
	TRY {
		CStdioFile f(GetApp()->GetStartDir()+fname,
			CFile::modeWrite|CFile::modeCreate|CFile::shareDenyNone|CFile::modeNoTruncate);
		f.Seek(0L,CFile::end);
		cs.AnsiToOem();
		time_cs=CTime::GetCurrentTime().Format("%d/%m/%y %H:%M:%S");
		f.WriteString(time_cs+" - "+cs+"\n");
		f.Close();	
	} CATCH(CFileException, e) {
			CString err;
			switch (e->m_cause) {
			case CFileException::none: break;
			case CFileException::generic: err="    "; break;
			case CFileException::fileNotFound: break;
			case CFileException::badPath: err=" .    "; break;
			case CFileException::tooManyOpenFiles: err="   .    "; break;
			case CFileException::accessDenied: err=" .    "; break;
			case CFileException::invalidFile: err=" .    "; break;
			case CFileException::removeCurrentDir: err="   .    "; break;
			case CFileException::directoryFull: err=" .    "; break;
			case CFileException::badSeek: break;
			case CFileException::hardIO: err=" .    "; break;
			case CFileException::sharingViolation: err=" .    "; break;
			case CFileException::lockViolation: err=" .    "; break;
			case CFileException::diskFull: err=" .    "; break;
			case CFileException::endOfFile: break;
			default: ;
		}
		Sleep(500); goto retry;
	}
	END_CATCH
}

void CConfPage::LoaderThreadProc(CConfPage &page)
{
	Sleep(1500);
	while (::IsWindow(page.m_hWnd)) {
		page.StartSTDPProcess();
	}
}

BOOL CConfPage::StartSTDPProcess()
{
	BOOL retv=FALSE;
	STARTUPINFO si;
 	PROCESS_INFORMATION pi;
	LPCSTR  pszExe="TGWconf.exe";
	CString exefile;
	CString cmdline;

	ZeroMemory(&si,sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO); 
	si.dwFlags=STARTF_USESHOWWINDOW;
	si.wShowWindow=SW_MINIMIZE;
	exefile.Format("%s\\%s",(LPCSTR)GetApp()->GetStartDir(),pszExe);
	cmdline.Format("%s %u",exefile,GetDlg()->m_ps.GetActiveIndex());

	retv=CreateProcess(
		exefile,					// name of executable module
		(char *)(LPCSTR)cmdline,	// command line string
		NULL, 
		NULL, 
		FALSE,						// handle inheritance flag
		NULL,						// creation flags
		NULL,						// new environment block
		NULL,						// current directory name
		&si, 
		&pi
		);

	if (retv) {
		m_pCfg->m_hConfProcess=pi.hProcess;
		// waiting for process termonation
		DWORD excode=STILL_ACTIVE;
		SetPriorityClass(pi.hProcess,IDLE_PRIORITY_CLASS);

		int retv = 0;
		while (excode==STILL_ACTIVE) {
			retv = GetExitCodeProcess(pi.hProcess,&excode);
			if (!retv) break;
			Sleep(50);
		}
		m_pCfg->m_hConfProcess=NULL;
	} else {
		WriteLog("  COMM  '%s'",pszExe);
		Sleep(5000);
	}

	return retv;
}
