// Config.cpp: implementation of the CConfig class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Config.h"
#include "RegAccess.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CConfig::CConfig()
{
	m_bUsingDialUp=FALSE;
	m_DialUpName="";
	m_bAutoUpdate=FALSE;
	m_bAskUser=FALSE;
	m_pDialerThread=NULL;
	Read();
}

CConfig::~CConfig()
{
}

BOOL CConfig::_Read(int n)
{
	BOOL suc;
	CConfigItem it;
	CRegAccess reg;

	CString cs;	cs.Format(" %03d",n);
	suc=reg.Create(HKEY_LOCAL_MACHINE,HKEY_SUBKEY);

	reg.GetString(REG_KEY_NAME+cs,&it.m_name);
	reg.GetString(REG_KEY_SERV_IP+cs,&it.m_serv_ip);
	reg.GetString(REG_KEY_SERV_PORT+cs,&it.m_serv_port);
	reg.GetString(REG_KEY_SERV_AA+cs,&it.m_serv_aa);
	reg.GetString(REG_KEY_LOCAL_AA+cs,&it.m_local_aa);
	reg.GetString(REG_KEY_IN_DIR+cs,&it.m_in_dir);
	reg.GetString(REG_KEY_OUT_DIR+cs,&it.m_out_dir);
	reg.GetString(REG_KEY_EMAIL+cs,&it.m_email);
	reg.GetString(REG_KEY_DISABLED+cs,&it.m_disabled);
	reg.GetString(REG_KEY_MAILENABLED+cs,&it.m_mailenabled);
	if (it.m_mailenabled.GetLength()<1) it.m_mailenabled="1";
	
	reg.Close();

	if (suc) Add(it);

	return suc;
}

BOOL CConfig::_Write(int n)
{
	BOOL suc;
	CConfigItem it=this->operator[](n);
	CRegAccess reg;

	CString cs;	cs.Format(" %03d",n);
	suc=reg.Create(HKEY_LOCAL_MACHINE,HKEY_SUBKEY);

	reg.PutString(REG_KEY_NAME+cs,it.m_name);
	reg.PutString(REG_KEY_SERV_IP+cs,it.m_serv_ip);
	reg.PutString(REG_KEY_SERV_PORT+cs,it.m_serv_port);
	reg.PutString(REG_KEY_SERV_AA+cs,it.m_serv_aa);
	reg.PutString(REG_KEY_LOCAL_AA+cs,it.m_local_aa);
	reg.PutString(REG_KEY_IN_DIR+cs,it.m_in_dir);
	reg.PutString(REG_KEY_OUT_DIR+cs,it.m_out_dir);
	reg.PutString(REG_KEY_EMAIL+cs,it.m_email);
	reg.PutString(REG_KEY_DISABLED+cs,it.m_disabled);
	reg.PutString(REG_KEY_MAILENABLED+cs,it.m_mailenabled);

	reg.Close();

	return suc;
}

void CConfig::Read()
{
	CString cs;
	CRegAccess reg;
	reg.Create(HKEY_LOCAL_MACHINE,HKEY_SUBKEY);
	reg.GetString(REG_KEY_USING_DIALUP,&cs);	m_bUsingDialUp=atoi(cs);
	reg.GetString(REG_KEY_DIALUP_NAME,&m_DialUpName);
	reg.GetString(REG_KEY_B_AUTOUPDATE,&cs);	m_bAutoUpdate=atoi(cs);
	reg.GetString(REG_KEY_B_ASKUSER,&cs);		m_bAskUser=atoi(cs);
	reg.GetString(REG_KEY_EMAIL_SRV,&cs);		m_email_srv=cs;
	if (m_email_srv.GetLength()<1) m_email_srv="10.61.1.1";
	reg.GetString(REG_KEY_NCONF,&cs);
	reg.Close();

	this->RemoveAll();
	for (int i=0; i<atoi(cs); i++) _Read(i);
}

void CConfig::Write()
{
	CRegAccess reg;

	for (int i=0; i<this->GetSize(); i++) _Write(i);

	CString cs; cs.Format("%d",this->GetSize());

	reg.Create(HKEY_LOCAL_MACHINE,HKEY_SUBKEY);
	reg.PutString(REG_KEY_NCONF,cs);
	reg.PutString(REG_KEY_USING_DIALUP,m_bUsingDialUp?"1":"0");
	reg.PutString(REG_KEY_DIALUP_NAME,m_DialUpName);
	reg.PutString(REG_KEY_B_AUTOUPDATE,m_bAutoUpdate?"1":"0");
	reg.PutString(REG_KEY_B_ASKUSER,m_bAskUser?"1":"0");
	reg.PutString(REG_KEY_EMAIL_SRV,m_email_srv);
	reg.Close();
}

BOOL CConfig::Check()
{
	if (GetSize()<1) return FALSE;

	for (int i=0; i<GetSize(); i++) {
		CConfigItem it=operator[](i);
		if (it.m_name.GetLength()<1) return FALSE;
		if (it.m_serv_ip.GetLength()<1) return FALSE;
		if (atol(it.m_serv_port)<1) return FALSE;
		if (it.m_serv_aa.GetLength()<1) return FALSE;
		if (it.m_local_aa.GetLength()<1) return FALSE;
		if (it.m_in_dir.GetLength()<1) return FALSE;
		if (it.m_out_dir.GetLength()<1) return FALSE;
	}

	return TRUE;
}
