// Config.h: interface for the CConfig class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONFIG_H__C20E55A7_EEC9_48BC_ADA6_0A7D3777B950__INCLUDED_)
#define AFX_CONFIG_H__C20E55A7_EEC9_48BC_ADA6_0A7D3777B950__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "afxtempl.h"
#include "ConfigItem.h"

// Registery keys
#define HKEY_SUBKEY					"SOFTWARE\\PVRRCC Saratov\\TGW"
#define REG_KEY_NAME				"Configuration name"
#define REG_KEY_NCONF				"Configuration counter"
#define REG_KEY_SERV_IP				"STDP Server IP address"
#define REG_KEY_SERV_PORT			"STDP Server IP port"
#define REG_KEY_SERV_AA				"STDP Server autoanswer"
#define REG_KEY_LOCAL_AA			"STDP Client autoanswer"
#define REG_KEY_IN_DIR				"Incoming spool directory"
#define REG_KEY_OUT_DIR				"Outgoing spool directory"
#define REG_KEY_EMAIL				"Send e-mail copy to"
#define REG_KEY_DISABLED			"Disabled flag"
#define REG_KEY_MAILENABLED			"Mail Enabled flag"

#define REG_KEY_EMAIL_SRV			"SMTP server for e-mail"
#define REG_KEY_PASSWORD			"Admin's password"
#define REG_KEY_USING_DIALUP		"Use dial-up connection"
#define REG_KEY_DIALUP_NAME			"Dial-up connection name"
#define REG_KEY_B_AUTOUPDATE		"Using autoupdate flag"
#define REG_KEY_B_ASKUSER			"Using ask user flag"

class CConfig : public CArray<CConfigItem,CConfigItem>  
{
public:
	CWinThread * m_pDialerThread;
	BOOL m_bUsingDialUp;
	CString m_DialUpName;
	BOOL m_bAutoUpdate;
	BOOL m_bAskUser;
	CString m_email_srv;
	//
	BOOL Check();
	void Write();
	void Read();
	BOOL _Write(int n);
	BOOL _Read(int n);
	CConfig();
	virtual ~CConfig();
};

#endif // !defined(AFX_CONFIG_H__C20E55A7_EEC9_48BC_ADA6_0A7D3777B950__INCLUDED_)
