// EditConfDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TGW6.h"
#include "EditConfDlg.h"
#include <io.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditConfDlg dialog


CEditConfDlg::CEditConfDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditConfDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditConfDlg)
	m_email = _T("");
	m_in_dir = _T("");
	m_local_aa = _T("");
	m_name = _T("");
	m_out_dir = _T("");
	m_serv_aa = _T("");
	m_serv_ip = _T("");
	m_serv_port = _T("");
	m_bmailenabled = FALSE;
	//}}AFX_DATA_INIT
}


void CEditConfDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditConfDlg)
	DDX_Text(pDX, IDC_EMAIL, m_email);
	DDX_Text(pDX, IDC_IN_DIR, m_in_dir);
	DDX_Text(pDX, IDC_LOCAL_AA, m_local_aa);
	DDX_Text(pDX, IDC_NAME, m_name);
	DDX_Text(pDX, IDC_OUT_DIR, m_out_dir);
	DDX_Text(pDX, IDC_SERV_AA, m_serv_aa);
	DDX_Text(pDX, IDC_SERV_IP, m_serv_ip);
	DDX_Text(pDX, IDC_SERV_PORT, m_serv_port);
	DDX_Check(pDX, IDC_BMAILENABLED, m_bmailenabled);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditConfDlg, CDialog)
	//{{AFX_MSG_MAP(CEditConfDlg)
	ON_BN_CLICKED(IDOK, OnOk)
	ON_BN_CLICKED(IDC_BMAILENABLED, OnBmailenabled)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditConfDlg message handlers

BOOL CEditConfDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	SetWindowText(m_title);
	if (m_title=="  STDP") {
		((CEdit *)GetDlgItem(IDC_NAME))->SetReadOnly(TRUE);
	}

	GetDlgItem(IDC_EMAIL)->EnableWindow(m_bmailenabled);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditConfDlg::OnOk() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	CString errmsg;

	m_name.TrimLeft(" ");  m_in_dir.TrimRight(" ");
	m_in_dir.TrimLeft(" ");  m_in_dir.TrimRight("\\// ");
	m_out_dir.TrimLeft(" ");  m_out_dir.TrimRight("\\// ");
	m_serv_ip.TrimLeft(" ");  m_serv_ip.TrimRight(" ");
	m_serv_port.TrimLeft(" ");  m_serv_port.TrimRight(" ");
	m_serv_aa.TrimLeft(" ");  m_serv_aa.TrimRight(" ");
	m_local_aa.TrimLeft(" ");  m_local_aa.TrimRight(" ");

	if (m_name.GetLength()<1 &&
		m_serv_ip.GetLength()<1 &&
		m_serv_port.GetLength()<1 &&
		atol(m_serv_ip)<1 &&
		m_serv_aa.GetLength()<1 &&
		m_local_aa.GetLength()<1 &&
		m_in_dir.GetLength()<1 &&
		m_out_dir.GetLength()<1) errmsg+="   !\n";
	else {
		if (m_name.GetLength()<1) errmsg+="   .\n";
		if (m_serv_ip.GetLength()<1) errmsg+="  IP    DNS  STDP .\n";
		if (atol(m_serv_port)<1) errmsg+="    IP  STDP .\n";
		if (m_serv_aa.GetLength()<1) errmsg+="   STDP .\n";
		if (m_local_aa.GetLength()<1) errmsg+="    .\n";
		if (m_in_dir.GetLength()<1) errmsg+="        .\n";
		else {
			if (_access(m_in_dir,6)) errmsg+="          .\n";
		}
		if (m_out_dir.GetLength()<1) errmsg+="        .\n";
		else {
			if (_access(m_out_dir,6)) errmsg+="          .\n";
		}

		//    
		CButton &b=*(CButton *)GetDlgItem(IDC_BMAILENABLED);
		if (b.GetCheck()) {
			if (m_email.Find('@')<=1) errmsg+="  e-mail  -   '@'.\n";
		}
	}

	if (errmsg.GetLength()>0) {
		Beep(3000,100);
		AfxMessageBox("A:\n\n"+errmsg,MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
	} else {
		UpdateData(FALSE);
		CDialog::OnOK();
	}
}

void CEditConfDlg::OnBmailenabled() 
{
	// TODO: Add your control notification handler code here
	CButton &b=*(CButton *)GetDlgItem(IDC_BMAILENABLED);
	GetDlgItem(IDC_EMAIL)->EnableWindow(b.GetCheck());
}
