// LogView.cpp: implementation of the CLogView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "tgw6.h"
#include "LogView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLogView::CLogView()
{

}

CLogView::~CLogView()
{

}

void CLogView::WriteLog(LPCSTR fmt, ...)
{
	va_list marker;
	CString cs,time_cs;
	if (GetNumItems()>100) DeleteItem(0);
	time_cs=CTime::GetCurrentTime().Format("%d/%m/%y %H:%M:%S");

	va_start(marker,fmt);
	cs.FormatV(fmt,marker);
	va_end(marker);

	AddItem(0,time_cs);
	AddItem(1,cs);

	SelectItem(GetNumItems()-1);
	GetListCtrl().EnsureVisible(GetNumItems()-1,TRUE);

	//    log-
	CString fname; fname.Format("\\TGWproto_%d.log",m_ncit);
	TRY {
		CStdioFile f(GetApp()->GetStartDir()+fname,
			CFile::modeWrite|CFile::modeCreate|CFile::shareDenyNone|CFile::modeNoTruncate);
		f.Seek(0L,CFile::end);
		cs.AnsiToOem();
		f.WriteString(time_cs+" --- "+cs+"\n");
		f.Close();	
	} CATCH(CFileException, e) {
			CString err;
			switch (e->m_cause) {
			case CFileException::none: break;
			case CFileException::generic: err="    "; break;
			case CFileException::fileNotFound: break;
			case CFileException::badPath: err=" .    "; break;
			case CFileException::tooManyOpenFiles: err="   .    "; break;
			case CFileException::accessDenied: err=" .    "; break;
			case CFileException::invalidFile: err=" .    "; break;
			case CFileException::removeCurrentDir: err="   .    "; break;
			case CFileException::directoryFull: err=" .    "; break;
			case CFileException::badSeek: break;
			case CFileException::hardIO: err=" .    "; break;
			case CFileException::sharingViolation: err=" .    "; break;
			case CFileException::lockViolation: err=" .    "; break;
			case CFileException::diskFull: err=" .    "; break;
			case CFileException::endOfFile: break;
			default: ;
		}
	}
	END_CATCH
}
