// Message.cpp: implementation of the CMessage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Message.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMessage::CMessage()
{
	m_sendtime=0;
	m_kvn=CreateKvn();
	m_text="";
}

CMessage::CMessage(CMessage &msg)
{
	*this=msg;
}

CMessage::CMessage(LPCSTR text)
{
	m_sendtime=0;
	m_ack=FALSE;
	m_text=text;
	m_kvn=CreateKvn();
}

CMessage::~CMessage()
{

}

CMessage & CMessage::operator=(CMessage &msg)
{
	m_ack=msg.m_ack;
	m_text=msg.m_text;
	m_kvn=msg.m_kvn;
	m_sendtime=msg.m_sendtime;
	return *this;
}

CMessage & CMessage::operator=(LPCSTR text)
{
	m_sendtime=0;
	m_ack=FALSE;
	m_text=text;
	m_kvn=CreateKvn();
	return *this;
}

CMessage::operator LPCSTR()
{
	return m_text;
}

UINT64 CMessage::CreateKvn()
{
	m_kvn=GetTickCount();
	return m_kvn;
}

CString CMessage::GetKvnString()
{
	CString rv;
	rv.Format("%012I64u",m_kvn);
	return rv;
}

void CMessage::SetSendTime()
{
	m_sendtime=GetTickCount();
}

DWORD CMessage::GetSendTime()
{
	return m_sendtime;
}

BOOL CMessage::GetAck()
{
	return m_ack;
}

void CMessage::SetAck(BOOL ack)
{
	m_ack=ack;
}
