// SmtpSocket.cpp: implementation of the CSmtpSocket class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SmtpSocket.h"
#include "../TGWMail/TGWMail.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSmtpSocket::CSmtpSocket()
{

}

CSmtpSocket::~CSmtpSocket()
{
	Disconnect();
}

void CSmtpSocket::OnDisconnect(int nErrorCode)
{
	ClearIOBuffers();
	ExitProcess(0);
}

void CSmtpSocket::OnConnectFin(int nErrorCode)
{
	ClearIOBuffers();
	if (nErrorCode) ExitProcess(0);
}

BOOL CSmtpSocket::SendMessage(CString to, CString from, CString msg, CString subj)
{
	CString repl;
	BOOL suc=TRUE,retv=FALSE;

	//      SMTP
	Putf("HELO TGW\n");						suc=GetAnswer(repl);	//  
	if (!suc || atol(repl)!=250) goto fin;
	Putf("MAIL FROM: %s\n",(LPCSTR)from);	suc=GetAnswer(repl);	//  
	if (!suc || atol(repl)!=250) goto fin;
	Putf("RCPT TO: %s\n",(LPCSTR)to);		suc=GetAnswer(repl);	//  
	if (!suc || atol(repl)!=250) goto fin;
	Putf("DATA\n");							suc=GetAnswer(repl);	//  
	if (!suc || atol(repl)!=354) goto fin;
	//   
	Putf("Sender: %s\n",(LPCSTR)from);
	srand((unsigned)time(NULL));
	Putf("Message-ID: <%lx.%x>\n",GetTickCount(),rand());
	TIME_ZONE_INFORMATION tzi;
	GetTimeZoneInformation(&tzi);
	Putf("Date: %s %+03d%02d\n",(LPCSTR)CTime().GetCurrentTime().Format("%a, %d %b %Y %H:%M:%S"),
		-tzi.Bias/60,abs(tzi.Bias%60));
	Putf("From: TGW <%s>\n",(LPCSTR)from);
	Putf("Organization: MPS\n");
	Putf("X-Mailer: TGW v. %s (C)PvRRCC 2000\n",(LPCSTR)GetApp()->GetCurrentVersion());
	Putf("X-Accept-Language: ru, en, nl\n");
	Putf("To: %s\n",(LPCSTR)to);
	Putf("Subject: %s\n",(LPCSTR)subj);
	Putf("Content-Type: text/plain; charset=cp866\n");
	Putf("Content-Transfer-Encoding: 8bit\n");
	Putf("Reply-To: %s\n",(LPCSTR)from);
	Putf("\n");
	//    
	Putf((LPCSTR)msg,msg.GetLength());
	//   
	Putf("\n.\n");					suc=GetAnswer(repl);	//  
	if (!suc || atol(repl)!=250) goto fin;
	//Putf("QUIT\n");					GetAnswer(repl);		//  
	retv=TRUE;
fin:
#ifdef _DEBUG	
	if (!retv) {
		OnError("    (SMTP):\n\n"+repl);
		ExitProcess(0);
	}
#endif
	return retv;
}

BOOL CSmtpSocket::GetAnswer(CString &s)
{
	
	while (TRUE) {
		if (Gets(s)) return TRUE;
		else {
			if (!IsConnected()) break;
		}
		Sleep(1);
	}
	return FALSE;
}
