// TGW6.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TGW6.h"
#include "TGWDlg.h"
#include <ras.h>
#include <raserror.h>
#include <afxinet.h>
#include "LogView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTGWApp

BEGIN_MESSAGE_MAP(CTGWApp, CWinApp)
	//{{AFX_MSG_MAP(CTGWApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTGWApp construction

CTGWApp::CTGWApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_rasapi32_hLib=NULL;
	m_hMailProcess=NULL;
	m_hInstProcess=NULL;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTGWApp object

CTGWApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTGWApp initialization

BOOL CTGWApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED,MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
		return FALSE;
	}

	// ,      
	if (__argc>1) {
		if (CString(__argv[1])=="/Restart") Sleep(5000);
	}

	if (FindInstance()) {
		Beep(3000,500); AfxMessageBox(" TGW  !",MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
		return FALSE;
	}

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	m_Icon_Green=LoadIcon(IDI_MAINGREEN);
	m_Icon_Red=LoadIcon(IDI_MAINRED);
	m_Icon_Blue=LoadIcon(IDI_MAINBLUE);
	m_Icon_Yellow=LoadIcon(IDI_MAINYELLOW);

	CreateMailSpool();
	
	CTGWDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

CString CTGWApp::GetCurrentVersion()
{
	return "6.0b";
}

BOOL CTGWApp::FindInstance()
{
	CString strCaption;
	strCaption.LoadString(AFX_IDS_APP_TITLE);

	CWnd* pwndFirst = CWnd::FindWindow((LPCSTR)(DWORD)WC_DIALOG,strCaption);
	if (pwndFirst) return TRUE;
	else return FALSE;
}

CString CTGWApp::GetStartDir()
{
	CString retv=__argv[0];
	int i=retv.ReverseFind('\\');
	if (i>=0) retv=retv.Left(i);
	else retv=".";
	return retv;
}

CString CTGWApp::GetMailSpoolDir()
{
	return GetStartDir()+"\\TGWmail";
}

BOOL CTGWApp::CreateMailSpool()
{
	BOOL suc=FALSE;
	TRY {
	suc=CreateDirectory(GetMailSpoolDir(),NULL);
	if (!suc && GetLastError()!=ERROR_ALREADY_EXISTS) {
		Beep(3000,100);
		AfxMessageBox("      \n"
			"  '"+GetMailSpoolDir()+"'!\n"
			",      \n"
			" /.   !"
			"",MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
		ExitTgw();
	}

	//   
		CFile ft(GetMailSpoolDir()+"\\dirinfo",CFile::modeWrite|CFile::modeCreate|CFile::shareDenyNone);
		CString buf="TGW "+GetApp()->GetCurrentVersion(); buf.AnsiToOem();
		ft.Write(buf,buf.GetLength());
		ft.Close();
	} CATCH(CFileException, e) {
		CString err;
		switch (e->m_cause) {
		case CFileException::none: break;
		case CFileException::generic: err="    "; break;
		case CFileException::fileNotFound: break;
		case CFileException::badPath: err=" .    "; break;
		case CFileException::tooManyOpenFiles: err="   .    "; break;
		case CFileException::accessDenied: err=" .    "; break;
		case CFileException::invalidFile: err=" .    "; break;
		case CFileException::removeCurrentDir: err="   .    "; break;
		case CFileException::directoryFull: err=" .    "; break;
		case CFileException::badSeek: break;
		case CFileException::hardIO: err=" .    "; break;
		case CFileException::sharingViolation: err=" .    "; break;
		case CFileException::lockViolation: err=" .    "; break;
		case CFileException::diskFull: err=" .    "; break;
		case CFileException::endOfFile: break;
		default: ;
		}
		Beep(3000,100);
		AfxMessageBox("    'dirinfo'  \n"
			"  '"+GetMailSpoolDir()+"'!\n"
			": "+err+"   !",MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
		ExitTgw();
	}
	END_CATCH

	return TRUE;
}

CString CTGWApp::GetDialLogFileName()
{
	return GetStartDir()+"\\TGWDial.log";
}

BOOL CTGWApp::DialUpConnect()
{
	CStringArray connarr;
	BOOL found=FALSE;
	BOOL retv=FALSE;
	UINT i;

	//   
	RASDIALPARAMS params;
	RASCONN rasconn[MAX_NCONN];
	HRASCONN m_conn=NULL;
	DWORD suc,nent,nconn;
	DWORD size1=sizeof(RASCONN)*MAX_NCONN;
	DWORD size2=sizeof(RASENTRYNAME)*MAX_ENT;

	//     rasapi32
	typedef DWORD (APIENTRY *TpRasHangUpA)(HRASCONN);
	typedef DWORD (APIENTRY *TpRasDialA)(LPRASDIALEXTENSIONS,LPCSTR,LPRASDIALPARAMSA,DWORD,LPVOID,LPHRASCONN);
	typedef DWORD (APIENTRY *TpRasEnumEntriesA)(LPCSTR,LPCSTR,LPRASENTRYNAMEA,LPDWORD,LPDWORD);
	typedef DWORD (APIENTRY *TpRasGetErrorStringA)(UINT,LPSTR,DWORD);
	typedef DWORD (APIENTRY *TpRasEnumConnectionsA)(LPRASCONNA,LPDWORD,LPDWORD);
	//  
	TpRasHangUpA pRasHangUp;
	TpRasDialA pRasDial;
	TpRasEnumEntriesA pRasEnumEntries;
	TpRasGetErrorStringA pRasGetErrorString;
	TpRasEnumConnectionsA pRasEnumConnections;

	if (!m_rasapi32_hLib) m_rasapi32_hLib=LoadLibrary("rasapi32");
	if (m_rasapi32_hLib) {
		BOOL libsuc=TRUE;
		pRasHangUp = (TpRasHangUpA) GetProcAddress(m_rasapi32_hLib, "RasHangUpA"); 
		pRasDial = (TpRasDialA) GetProcAddress(m_rasapi32_hLib, "RasDialA"); 
		pRasEnumEntries = (TpRasEnumEntriesA) GetProcAddress(m_rasapi32_hLib, "RasEnumEntriesA"); 
		pRasGetErrorString = (TpRasGetErrorStringA) GetProcAddress(m_rasapi32_hLib, "RasGetErrorStringA"); 
		pRasEnumConnections = (TpRasEnumConnectionsA) GetProcAddress(m_rasapi32_hLib, "RasEnumConnectionsA"); 
		//       - Rasapi32.dll
		if (pRasHangUp==NULL) libsuc=FALSE;
		if (pRasDial==NULL) libsuc=FALSE;
		if (pRasEnumEntries==NULL) libsuc=FALSE;
		if (pRasGetErrorString==NULL) libsuc=FALSE;
		if (pRasEnumConnections==NULL) libsuc=FALSE;
		if (!libsuc) {
			AfxMessageBox("   !\n"
				" Dial-Up  .\n\n"
				"   .",MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
			ExitTgw();
		}
	} else {
		AfxMessageBox("    !\n"
			" Dial-Up  .\n\n"
			"  .",MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
		ExitTgw();
	}

	//    
	//    
	rasconn[0].dwSize=sizeof(RASCONN);
	if ((suc=(pRasEnumConnections)(rasconn,&size1,&nconn))!=0) {
		//   
		char err[MAX_ERR_BUF+1];
		(pRasGetErrorString)(suc,err,MAX_ERR_BUF);
		if (suc!=603) PrintDialLog("RasEnumConnections(): suc=%ld '%s'",suc,err);
		m_conn=NULL; return FALSE;
	}
	//   
	if (nconn>0) {
		retv=TRUE;			//     1  -  
		goto fin;
	} 

	EnumDialUpConnections(connarr);
	nent=connarr.GetSize();
	for (i=0; i<nent; i++) {
		if (connarr[i]==m_config.m_DialUpName) {
			found=TRUE;
			break;
		}
	}
	if (!found) {
		AfxMessageBox("    '"+m_config.m_DialUpName+"'  !\n"
			" Dial-Up     .\n\n"
			"  .",MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
		return FALSE;
	}

retry:
	//   
	//  
	params.dwSize=sizeof(RASDIALPARAMS);
	strcpy(params.szEntryName,m_config.m_DialUpName);
	strcpy(params.szPhoneNumber,"");
	strcpy(params.szCallbackNumber,"");
	strcpy(params.szUserName,"user");
	strcpy(params.szPassword,"password");
	strcpy(params.szDomain,"");
	m_conn=NULL;
	//  
	PrintDialLog("Connecting to RAS entry '%s'",params.szEntryName);
	if ((suc=(pRasDial)(NULL,NULL,&params,NULL,NULL,&m_conn))!=0) {
			char err[MAX_ERR_BUF+1];
			(pRasGetErrorString)(suc,err,MAX_ERR_BUF);
			PrintDialLog("RasDial(): suc=%ld '%s'",suc,err);
			PrintDialLog("Attempt to close active port");
			if ((pRasHangUp)(m_conn)!=0) {
				char err[MAX_ERR_BUF+1];
				(pRasGetErrorString)(suc,err,MAX_ERR_BUF);
				PrintDialLog("RasHangUp(): suc=%ld '%s'",suc,err);
			}
			Sleep(WAIT_TIME); m_conn=NULL;
			goto retry;
	} else {
		retv=TRUE; 
		goto fin;
	}
fin:
	return retv;
}

CStringArray & CTGWApp::EnumDialUpConnections(CStringArray &arr)
{
	UINT i;
	
	//   
	RASENTRYNAME ent[MAX_ENT];
	HRASCONN m_conn=NULL;
	DWORD suc,nent;
	DWORD size1=sizeof(RASCONN)*MAX_NCONN;
	DWORD size2=sizeof(RASENTRYNAME)*MAX_ENT;

	//     rasapi32
	typedef DWORD (APIENTRY *TpRasHangUpA)(HRASCONN);
	typedef DWORD (APIENTRY *TpRasDialA)(LPRASDIALEXTENSIONS,LPCSTR,LPRASDIALPARAMSA,DWORD,LPVOID,LPHRASCONN);
	typedef DWORD (APIENTRY *TpRasEnumEntriesA)(LPCSTR,LPCSTR,LPRASENTRYNAMEA,LPDWORD,LPDWORD);
	typedef DWORD (APIENTRY *TpRasGetErrorStringA)(UINT,LPSTR,DWORD);
	typedef DWORD (APIENTRY *TpRasEnumConnectionsA)(LPRASCONNA,LPDWORD,LPDWORD);
	//  
	TpRasHangUpA pRasHangUp;
	TpRasDialA pRasDial;
	TpRasEnumEntriesA pRasEnumEntries;
	TpRasGetErrorStringA pRasGetErrorString;
	TpRasEnumConnectionsA pRasEnumConnections;

	arr.RemoveAll();

	if (!m_rasapi32_hLib) m_rasapi32_hLib=LoadLibrary("rasapi32");
	if (m_rasapi32_hLib) {
		pRasHangUp = (TpRasHangUpA) GetProcAddress(m_rasapi32_hLib, "RasHangUpA"); 
		pRasDial = (TpRasDialA) GetProcAddress(m_rasapi32_hLib, "RasDialA"); 
		pRasEnumEntries = (TpRasEnumEntriesA) GetProcAddress(m_rasapi32_hLib, "RasEnumEntriesA"); 
		pRasGetErrorString = (TpRasGetErrorStringA) GetProcAddress(m_rasapi32_hLib, "RasGetErrorStringA"); 
		pRasEnumConnections = (TpRasEnumConnectionsA) GetProcAddress(m_rasapi32_hLib, "RasEnumConnectionsA"); 
		//       - Rasapi32.dll
		if (pRasHangUp==NULL) {goto fin;}
		if (pRasDial==NULL) {goto fin;}
		if (pRasEnumEntries==NULL) {goto fin;}
		if (pRasGetErrorString==NULL) {goto fin;}
		if (pRasEnumConnections==NULL) {goto fin;}
	} else goto fin;

	//       
	ent[0].dwSize=sizeof(RASENTRYNAME);
	if ((suc=(pRasEnumEntries)(NULL,NULL,ent,&size2,&nent))!=0) {
		char err[MAX_ERR_BUF+1];
		(pRasGetErrorString)(suc,err,MAX_ERR_BUF);
		m_conn=NULL; goto fin;
	}
	//   
	for (i=0; i<nent; i++) {
		arr.Add(ent[i].szEntryName);
	}
fin:

	return arr;
}

void CTGWApp::PrintDialLog(const char *fmt, ...)
{
	va_list pvar;  va_start(pvar,fmt);
	CString cs; cs.FormatV(fmt,pvar);
	va_end(pvar);

	CTime t=CTime::GetCurrentTime();
	cs=t.Format("[ %d/%b/%Y (%H:%M:%S) ]:  ")+cs;

	FILE *h=fopen(GetDialLogFileName(),"a+");
	if (h) {
		cs.AnsiToOem();
		fprintf(h,"%s\n",(LPCSTR)cs);
		fclose(h);
	}
}

void CTGWApp::ExitTgw()
{
	DWORD exitcode;
	for (int i=0; i<m_config.GetSize(); i++) {
		CConfigItem &cfg=m_config[i];
retry_suspend:
		if (cfg.m_pLoaderThread) {
			if (cfg.m_pLoaderThread->SuspendThread()!=(DWORD)-1) cfg.m_pLoaderThread=NULL;
			else { Sleep(1); goto retry_suspend; }
			}
retry_terminate:
		if (cfg.m_hConfProcess) {
			if (GetExitCodeProcess(cfg.m_hConfProcess,&exitcode)) {
				if (exitcode==STILL_ACTIVE) {
					if (TerminateProcess(cfg.m_hConfProcess,0)) cfg.m_hConfProcess=NULL;
					else { Sleep(1); goto retry_terminate; }
				} else cfg.m_hConfProcess=NULL;
			}
		}
	}

retry_mailterminate:
	if (m_hMailProcess) {
		if (GetExitCodeProcess(m_hMailProcess,&exitcode)) {
			if (exitcode==STILL_ACTIVE) {
				if (TerminateProcess(m_hMailProcess,0)) m_hMailProcess=NULL;
				else { Sleep(1); goto retry_mailterminate; }
			} else m_hMailProcess=NULL;
		} else m_hMailProcess=NULL;
	}

	GetDlg()->ManageTaskbarIcon(NIM_DELETE,IDI_TASKICON,0,DEFAULT_MSG);
	
	ExitProcess(0);
}

void CTGWApp::DialerThreadProc()
{
	while (TRUE) {
		if (GetApp()->m_config.m_bUsingDialUp) GetApp()->DialUpConnect();
		Sleep(10000);
	}
}

void CTGWApp::PrintLogWin(UINT ncit, LPCSTR fmt, ...)
{
	if (ncit>=0 && ncit<(UINT)m_config.GetSize()) {
		if (m_config[ncit].m_pLogView) {
			if (IsWindow(m_config[ncit].m_pLogView->m_hWnd)) {
				CString cs;
				va_list marker;
				va_start(marker,fmt);
				cs.FormatV(fmt,marker);
				va_end(marker);
				m_config[ncit].m_pLogView->WriteLog("%s",cs);
			}
		}
	}
}

void CTGWApp::MailerThreadProc()
{
	HANDLE dh=FindFirstChangeNotification(GetApp()->GetMailSpoolDir(),FALSE,
		FILE_NOTIFY_CHANGE_FILE_NAME|FILE_NOTIFY_CHANGE_SIZE|FILE_NOTIFY_CHANGE_LAST_WRITE);

	while (TRUE) {
		//     ,     5 
		WaitForSingleObject(dh,10000u);
		//      ,   
		GetApp()->StartMailerProcess();
		//      
		FindNextChangeNotification(dh);
	}

	FindCloseChangeNotification(dh);
}

BOOL CTGWApp::StartMailerProcess()
{
	BOOL retv=FALSE;
	STARTUPINFO si;
 	PROCESS_INFORMATION pi;
	LPCSTR  pszExe="TGWmail.exe";
	CString exefile;
	CString cmdline;

	ZeroMemory(&si,sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO); 
	si.dwFlags=STARTF_USESHOWWINDOW;
	si.wShowWindow=SW_MINIMIZE;
	exefile.Format("%s\\%s",(LPCSTR)GetApp()->GetStartDir(),pszExe);
	cmdline.Format("%s %u",exefile,GetDlg()->m_ps.GetActiveIndex());

	retv=CreateProcess(
		exefile,					// name of executable module
		(char *)(LPCSTR)cmdline,	// command line string
		NULL, 
		NULL, 
		FALSE,						// handle inheritance flag
		NULL,						// creation flags
		NULL,						// new environment block
		NULL,						// current directory name
		&si, 
		&pi
		);

	if (retv) {
		// waiting for process termonation
		DWORD excode=STILL_ACTIVE;
		m_hMailProcess=pi.hProcess;
		SetPriorityClass(pi.hProcess,IDLE_PRIORITY_CLASS);

		int retv = 0;
		while (excode==STILL_ACTIVE) {
			retv = GetExitCodeProcess(pi.hProcess,&excode);
			if (!retv) break;
			Sleep(50);
		}
		m_hMailProcess=NULL;
	} else {
		Sleep(5000);
	}

	return retv;
}

void CTGWApp::FtpThreadProc()
{
CheckNet:
	for (int i=0; i<GetApp()->m_config.GetSize(); i++) {
		if (GetApp()->m_config[i].m_stdp_status==CWinSTDP::WinSTDPStatus::CONN_OK) goto beginFTP;
	}
	Sleep(5000); goto CheckNet;

beginFTP:
	//   
	CString newversion;
	if (GetApp()->FtpGetVersion(newversion)) {
		if (newversion>GetApp()->GetCurrentVersion() && GetApp()->m_config.m_bAutoUpdate) {
			CString cs;
			cs="   TGW "+GetApp()->GetCurrentVersion();
			cs+="\n    "+newversion;
			cs+="\n";
			cs+="\n      ?";

			int msgboxres=IDOK;
			//      
			if (GetApp()->m_config.m_bAskUser)
				msgboxres=AfxMessageBox(cs,MB_OKCANCEL|MB_ICONQUESTION|MB_SYSTEMMODAL);
			
			if (msgboxres==IDOK) {
				if (GetApp()->FtpGetNewSetupFile()) {
					cs="    .\n\n";
					cs+="     ?";

					//      
					if (GetApp()->m_config.m_bAskUser) {
						Beep(3000,100);
						msgboxres=AfxMessageBox(cs,MB_OKCANCEL|MB_ICONQUESTION|MB_SYSTEMMODAL);
					}

					if (msgboxres==IDOK) {
						STARTUPINFO siStartInfo;
						ZeroMemory(&siStartInfo,sizeof(STARTUPINFO));
						siStartInfo.cb=sizeof(STARTUPINFO);
						siStartInfo.lpTitle=NULL;
						PROCESS_INFORMATION piProcInfo;
						ZeroMemory(&piProcInfo,sizeof(PROCESS_INFORMATION));

						CString cmdline;
						cmdline=GetApp()->GetStartDir()+"\\TGWinst.exe 0";

						if (!CreateProcess(NULL,
							(char *)(LPCSTR)cmdline,
							NULL,			// process security attributes 
							NULL,			// primary thread security attributes
							FALSE,			// handles are not inherited
							IDLE_PRIORITY_CLASS,	// creation flags
							NULL,			// use parent's environment
							NULL,			// use parent's current directory
							&siStartInfo,	// STARTUPINFO pointer
							&piProcInfo		// receives PROCESS_INFORMATION
							)) {
							if (GetApp()->m_config.m_bAskUser) {
								Beep(3000,100);
								AfxMessageBox("    TGWinst.EXE\n  TGW!",MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
							}
						} else {
							ExitProcess(0);
						}
					}
				}
				else {
					if (GetApp()->m_config.m_bAskUser) {
						Beep(3000,100);
						AfxMessageBox("     "+newversion,MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
					}
				}
			}
		}
	}
	
	Sleep(10000);
}

BOOL CTGWApp::FtpGetVersion(CString &ver)
{
	BOOL retv=FALSE;
	FILE *f;
	
	ver="";
	
	CFtpConnection *pFc;
	CInternetSession *pIs=new CInternetSession(NULL,1,INTERNET_OPEN_TYPE_DIRECT);
	if (!pIs) {
		goto fin;
	}
	
	try	{
		pFc=pIs->GetFtpConnection("ftp.pvrr.mps","ftp","tgw@");
	}
	catch (CInternetException *)	{
			goto fin;
	}

	//    
	if (!pFc->SetCurrentDirectory("/pub/pvrr/tgw")) goto fin;
	//   
	if (!pFc->GetFile("/pub/pvrr/tgw/version",GetStartDir()+"\\version.new",FALSE,FILE_READ_ATTRIBUTES,FTP_TRANSFER_TYPE_ASCII))	goto fin;

	f=fopen(GetStartDir()+"\\version.new","rt");
	if (f) {
		char *p=ver.GetBuffer(1025);
		p[0]=0;
		fgets(p,1024,f);
		for (int i=0; p[i]; i++) {
			if (p[i]=='\r') p[i]=0;
			if (p[i]=='\n') p[i]=0;
		}
		ver.ReleaseBuffer();
		retv=TRUE;
		fclose(f);
	}

fin:
	if (pIs) delete pIs;
	return retv;
}

BOOL CTGWApp::FtpGetNewSetupFile()
{
	BOOL retv=FALSE;
	
	CFtpConnection *pFc;
	CInternetSession *pIs=new CInternetSession(NULL,1,INTERNET_OPEN_TYPE_DIRECT);
	if (!pIs) {
		goto fin;
	}
	
	try	{
		pFc=pIs->GetFtpConnection("ftp.pvrr.mps","ftp","tgw@");
	}
	catch (CInternetException *)	{
			goto fin;
	}

	//    
	if (!pFc->SetCurrentDirectory("/pub/pvrr/tgw")) goto fin;
	//   
	if (!pFc->GetFile("/pub/pvrr/tgw/tgwsetup.exe",GetStartDir()+"\\tgwsetup.exe",FALSE,FILE_ATTRIBUTE_NORMAL,FTP_TRANSFER_TYPE_BINARY)) goto fin;
	retv=TRUE;

fin:
	if (pIs) delete pIs;
	return retv;
}
