// TGW6.h : main header file for the TGW6 application
//

#if !defined(AFX_TGW6_H__B32E413F_7EB1_4793_B73F_00C07F75A98D__INCLUDED_)
#define AFX_TGW6_H__B32E413F_7EB1_4793_B73F_00C07F75A98D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include "Config.h"	// Added by ClassView
#include "TGWDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CTGWApp:
// See TGW6.cpp for the implementation of this class
//
#define DEFAULT_MSG			"TGW"
#define WMU_TASKBAR			(WM_USER+1)
#define WMU_SETACTIVE		(WM_USER+2)

#define MAX_ERR_BUF	1000
#define MAX_NCONN	100
#define MAX_ENT		100
#define CHECK_TIME	2000
#define WAIT_TIME	10000

class CTGWApp : public CWinApp
{
	HINSTANCE m_rasapi32_hLib;
public:
	BOOL FtpGetNewSetupFile();
	BOOL FtpGetVersion(CString &ver);
	HANDLE m_hMailProcess;		//   
	HANDLE m_hInstProcess;		//  
	BOOL StartMailerProcess();
	void PrintLogWin(UINT ncit, LPCSTR fmt, ...);
	static void DialerThreadProc();
	static void FtpThreadProc();
	static void MailerThreadProc();
	HICON m_Icon_Green;
	HICON m_Icon_Red;
	HICON m_Icon_Blue;
	HICON m_Icon_Yellow;
	void ExitTgw();
	void PrintDialLog(const char *fmt, ...);
	CStringArray & EnumDialUpConnections(CStringArray &arr);
	BOOL DialUpConnect();
	CString GetDialLogFileName();
	BOOL CreateMailSpool();
	CString GetMailSpoolDir();
	CString GetStartDir();
	CConfig m_config;
	BOOL FindInstance();
	CString GetCurrentVersion();
	CTGWApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTGWApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CTGWApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

inline CTGWApp * GetApp() {return (CTGWApp *)AfxGetApp();}
inline CTGWDlg * GetDlg() {return (CTGWDlg *)GetApp()->GetMainWnd();}

#endif // !defined(AFX_TGW6_H__B32E413F_7EB1_4793_B73F_00C07F75A98D__INCLUDED_)
