// TGWDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TGW6.h"
#include "TGWDlg.h"
#include "EditConfDlg.h"
#include "EditConfCommon.h"
#include "ConfPage.h"
#include "Common.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_staticver;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_staticver = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_STATICVER, m_staticver);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTGWDlg dialog

CTGWDlg::CTGWDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTGWDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTGWDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hIconSmall = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_ppsFrame=NULL;
}

void CTGWDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTGWDlg)
	DDX_Control(pDX, IDC_PROPFRAME, m_Frame);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTGWDlg, CDialog)
	//{{AFX_MSG_MAP(CTGWDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_ABOUT, OnAbout)
	ON_COMMAND(ID_MINIMIZE, OnMinimize)
	ON_COMMAND(ID_EXIT, OnExit)
	ON_COMMAND(ID_CONF_ADD, OnConfAdd)
	ON_COMMAND(ID_CONF_EDIT, OnConfEdit)
	ON_COMMAND(ID_CONF_DEL, OnConfDel)
	ON_COMMAND(ID_CONF_COMMON, OnConfCommon)
	ON_COMMAND(ID_CONF_OFFLINE, OnConfOffline)
	ON_COMMAND(ID_DIAG_STDP, OnDiagStdp)
	ON_WM_COPYDATA()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTGWDlg message handlers

BOOL CTGWDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	ResizeLogo();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, " ");
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_menu.LoadMenu(IDR_MENU);
	SetMenu(&m_menu);
	((CFrameWnd *)GetApp()->GetMainWnd())->m_hMenuDefault = m_menu.m_hMenu;
	ApplyConfig();

	AfxBeginThread((AFX_THREADPROC)GetApp()->DialerThreadProc,NULL);
	AfxBeginThread((AFX_THREADPROC)GetApp()->MailerThreadProc,NULL);
	AfxBeginThread((AFX_THREADPROC)GetApp()->FtpThreadProc,NULL);

	CTelnetSocket *pS=new CTelnetSocket;
	pS->Server(10023,&m_tSock);

	if (GetApp()->m_config.GetSize()>0)
		PostMessage(WM_SYSCOMMAND,SC_MINIMIZE,0);	//   
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTGWDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		switch (nID) {
		case SC_MINIMIZE:
			{
				CDialog::OnSysCommand(nID, lParam);
				ManageTaskbarIcon(NIM_ADD,IDI_TASKICON,0,DEFAULT_MSG);
				ShowWindow(SW_HIDE);
				break;
			}
		case SC_RESTORE:
			{
				CDialog::OnSysCommand(nID, lParam);
				ManageTaskbarIcon(NIM_DELETE,IDI_TASKICON,0,DEFAULT_MSG);
				ShowWindow(SW_SHOW);
				break;
			}
		case SC_CLOSE:
			{
				if (AfxMessageBox("     TGW ?",MB_OKCANCEL|MB_ICONQUESTION|MB_SYSTEMMODAL)==IDOK) {
					GetApp()->ExitTgw();
				}
				break;
			}
		default: CDialog::OnSysCommand(nID, lParam);
		}
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTGWDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		if (m_ps.GetPageCount()>0) {
			m_Frame.ModifyStyle(SS_BITMAP, SS_WHITEFRAME);
		}else{
			m_Frame.ModifyStyle(SS_WHITEFRAME, SS_BITMAP);
		}

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTGWDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_staticver=GetApp()->GetCurrentVersion();
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTGWDlg::OnAbout() 
{
	// TODO: Add your command handler code here
	SendMessage(WM_SYSCOMMAND,IDM_ABOUTBOX);
}

void CTGWDlg::OnMinimize() 
{
	// TODO: Add your command handler code here
	SendMessage(WM_SYSCOMMAND,SC_MINIMIZE);
}

void CTGWDlg::OnExit() 
{
	// TODO: Add your command handler code here
	SetFocus();
	SendMessage(WM_SYSCOMMAND,SC_CLOSE);
}

void CTGWDlg::OnOK()
{
}

void CTGWDlg::OnCancel()
{
	SendMessage(WM_SYSCOMMAND,SC_CLOSE);
}

void CTGWDlg::ManageTaskbarIcon(UINT cmd, UINT iconID, UINT nID, LPSTR str)
{
	NOTIFYICONDATA tnid; 
	HICON hicon=GetApp()->LoadIcon(iconID);
 
	tnid.cbSize=sizeof(NOTIFYICONDATA); 
	tnid.hWnd=m_hWnd; 
	tnid.uID=nID;
	tnid.uFlags=NIF_MESSAGE|NIF_ICON|NIF_TIP; 
	tnid.uCallbackMessage=WMU_TASKBAR; 
	tnid.hIcon=hicon;
	if (str) lstrcpyn(tnid.szTip,str,sizeof(tnid.szTip));
	else tnid.szTip[0]=0; 
 
	Shell_NotifyIcon(cmd, &tnid);
	if (hicon) DestroyIcon(hicon);
}

LRESULT CTGWDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch (message) {
	case WMU_SETACTIVE:
					{
						CWnd *pDeskTop=GetDesktopWindow();
						if (pDeskTop) GetDesktopWindow()->SendMessage(WM_SYSCOMMAND,SC_TASKLIST);
						break;
					}
	case WMU_TASKBAR: {
						switch (lParam) {
							case WM_RBUTTONDOWN: Beep(5000,200); break;
							case WM_LBUTTONDOWN: 
								CDialog::DefWindowProc(WM_SYSCOMMAND, SC_RESTORE, 0);
								ShowWindow(SW_SHOW);
								PostMessage(WM_SYSCOMMAND,SC_RESTORE);
								SetForegroundWindow();
								BringWindowToTop();
								EnableWindow();
								break;
						}
						break;
					  }
	default:
		return CDialog::DefWindowProc(message, wParam, lParam);
	}
	return NULL;
}

void CTGWDlg::OnConfAdd() 
{
	// TODO: Add your command handler code here
	CEditConfDlg dlg;
	dlg.m_title="   STDP";
	dlg.m_bmailenabled=FALSE;
retry:	
	if (dlg.DoModal()==IDOK) {
		CConfigItem Cfg;
		Cfg.m_serv_port=dlg.m_serv_port;
		Cfg.m_out_dir=dlg.m_out_dir;
		Cfg.m_in_dir=dlg.m_in_dir;
		Cfg.m_email=dlg.m_email;
		Cfg.m_local_aa=dlg.m_local_aa;
		Cfg.m_name=dlg.m_name;
		Cfg.m_serv_aa=dlg.m_serv_aa;
		Cfg.m_serv_ip=dlg.m_serv_ip;
		Cfg.m_mailenabled=dlg.m_bmailenabled?"1":"0";

		CString err="";
		for (int i=0; i<GetApp()->m_config.GetSize(); i++) {
			if (dlg.m_name.CompareNoCase(GetApp()->m_config[i].m_name)==0) {
				err+="\n     ,   !";
				break;
			}
		}

		if (err.GetLength()<1) {
			GetApp()->m_config.Add(Cfg);
			GetApp()->m_config.Write();
			i=GetApp()->m_config.GetSize()-1;
			if (!IsWindow(m_ps.m_hWnd)) {
				m_ps.AddPage(new CConfPage(&GetApp()->m_config[i]));
				m_ps.Create(m_ppsFrame,this);
			} else {
				m_ps.AddPage(new CConfPage(&GetApp()->m_config[i]));
			}
			Sleep(200);
			m_ps.SetActivePage(i);
		} else {
			MessageBox(err,"",MB_OK|MB_ICONWARNING);
			goto retry;
		}
	}
}

void CTGWDlg::OnConfEdit() 
{
	// TODO: Add your command handler code here
	CEditConfDlg dlg;
	dlg.m_title="  STDP";

	if (m_ps.GetPageCount()>0) {
		int i=m_ps.GetActiveIndex();
		CConfigItem &Cfg=GetApp()->m_config[i];
		dlg.m_serv_port=Cfg.m_serv_port;
		dlg.m_out_dir=Cfg.m_out_dir;
		dlg.m_in_dir=Cfg.m_in_dir;
		dlg.m_email=Cfg.m_email;
		dlg.m_local_aa=Cfg.m_local_aa;
		dlg.m_name=Cfg.m_name;
		dlg.m_serv_aa=Cfg.m_serv_aa;
		dlg.m_serv_ip=Cfg.m_serv_ip;
		dlg.m_bmailenabled=atoi(Cfg.m_mailenabled);
		if (dlg.DoModal()==IDOK) {
retry_suspend:
			if (Cfg.m_pLoaderThread->SuspendThread()!=(DWORD)-1) ;
			else {Sleep(1); goto retry_suspend;}
			TerminateProcess(Cfg.m_hConfProcess,0);
			Cfg.m_serv_port=dlg.m_serv_port;
			Cfg.m_out_dir=dlg.m_out_dir;
			Cfg.m_in_dir=dlg.m_in_dir;
			Cfg.m_email=dlg.m_email;
			Cfg.m_local_aa=dlg.m_local_aa;
			Cfg.m_name=dlg.m_name;
			Cfg.m_serv_aa=dlg.m_serv_aa;
			Cfg.m_serv_ip=dlg.m_serv_ip;
			Cfg.m_mailenabled=dlg.m_bmailenabled?"1":"0";
			GetApp()->m_config.Write();
retry_resume:
			if (Cfg.m_pLoaderThread->ResumeThread()!=(DWORD)-1) ;
			else {Sleep(1); goto retry_resume;}
		}
	} else {
		MessageBox("   ,  !","",MB_OK|MB_ICONWARNING);
	}
}

void CTGWDlg::OnConfDel() 
{
	// TODO: Add your command handler code here
	if (m_ps.GetPageCount()>0) {
		int i=m_ps.GetActiveIndex();
		if (MessageBox("   ,   "
			"\n   '"+GetApp()->m_config[i].m_name+"' ?","",MB_OKCANCEL)==IDOK) {

			if (GetApp()->m_config[i].m_pLoaderThread) {
retry_suspend:
				if (GetApp()->m_config[i].m_pLoaderThread->SuspendThread()!=(DWORD)-1) ;
				else { Sleep(1); goto retry_suspend; }
				GetApp()->m_config[i].m_pLoaderThread=NULL;
			}
			if (GetApp()->m_config[i].m_hConfProcess) {
				TerminateProcess(GetApp()->m_config[i].m_hConfProcess,0);
				GetApp()->m_config[i].m_hConfProcess=NULL;
			}

			m_ps.RemovePage(i);
			if (m_ps.GetPageCount()<1) m_ps.DestroyWindow();
			GetApp()->m_config.RemoveAt(i);
			GetApp()->m_config.Write();
		}
	} else {
		MessageBox("   ,  !","",MB_OK|MB_ICONWARNING);
	}
}

void CTGWDlg::OnConfCommon() 
{
	// TODO: Add your command handler code here
	CEditConfCommon dlg;
	dlg.m_busedialup=GetApp()->m_config.m_bUsingDialUp;
	dlg.m_bAutoUpdate=GetApp()->m_config.m_bAutoUpdate;
	dlg.m_bAskUser=GetApp()->m_config.m_bAskUser;
	dlg.m_email_srv=GetApp()->m_config.m_email_srv;
	if (dlg.DoModal()==IDOK) {
		GetApp()->m_config.m_bUsingDialUp=dlg.m_busedialup;
		GetApp()->m_config.m_bAutoUpdate=dlg.m_bAutoUpdate;
		GetApp()->m_config.m_bAskUser=dlg.m_bAskUser;
		GetApp()->m_config.m_email_srv=dlg.m_email_srv;
		GetApp()->m_config.Write();
	}
}

void CTGWDlg::OnConfOffline() 
{
	// TODO: Add your command handler code here
	DWORD exitcode;
	if (m_ps.GetPageCount()>0) {
		int i=m_ps.GetActiveIndex();
		CConfigItem &cfg=GetApp()->m_config[i];
		if (m_menu.CheckMenuItem(ID_CONF_OFFLINE,MF_UNCHECKED|MF_BYCOMMAND)==MF_CHECKED) {
			cfg.m_disabled="0";
retry_resume:
			if (cfg.m_pLoaderThread)
				if (cfg.m_pLoaderThread->ResumeThread()!=(DWORD)-1) ;
				else  { Sleep(1); goto retry_resume; }
		} else {
			m_menu.CheckMenuItem(ID_CONF_OFFLINE,MF_CHECKED|MF_BYCOMMAND);
retry_suspend:
			cfg.m_disabled="1";
			if (cfg.m_pLoaderThread) {
				if (cfg.m_pLoaderThread->SuspendThread()!=(DWORD)-1) {
retry_terminate:
					if (cfg.m_hConfProcess) {
						if (GetExitCodeProcess(cfg.m_hConfProcess,&exitcode)) {
							if (exitcode==STILL_ACTIVE) {
								if (TerminateProcess(cfg.m_hConfProcess,0)) cfg.m_hConfProcess=NULL;
								else { Sleep(1); goto retry_terminate; }
							} else cfg.m_hConfProcess=NULL;
						} else cfg.m_hConfProcess=NULL;
					}
				} else { Sleep(1); goto retry_suspend; }
			}
		}
		GetApp()->m_config.Write();
	} else {
		MessageBox("   ,  !","",MB_OK|MB_ICONWARNING);
	}
}

void CTGWDlg::ResizeLogo()
{
	const int margin=5;
	m_ppsFrame=GetDlgItem(IDC_PROPFRAME);
	CRect r,rn;
	GetClientRect(&r);
	rn=r;
	rn.left+=margin;
	rn.top+=margin;
	rn.right-=margin;
	rn.bottom-=margin+20;

	m_ppsFrame->MoveWindow(&rn);
}

void CTGWDlg::ApplyConfig()
{
	GetApp()->m_config.Read();
	if (IsWindow(m_ps.m_hWnd)) m_ps.DestroyWindow();

	for (int i=0; i<GetApp()->m_config.GetSize(); i++)
		m_ps.AddPage(new CConfPage(&GetApp()->m_config[i]));

	if (m_ps.Create(m_ppsFrame,this)) {
		for (int i=0; i<GetApp()->m_config.GetSize(); i++)
			m_ps.SetActivePage(i);
		m_ps.SetActivePage(0);
	}
}

void CTGWDlg::OnDiagStdp() 
{
	// TODO: Add your command handler code here
	if (m_ps.GetPageCount()>0) {
		int i=m_ps.GetActiveIndex();
		CConfigItem &Cfg=GetApp()->m_config[i];
		if (Cfg.m_disabled=="1") {
			//    
			AfxBeginThread((AFX_THREADPROC)TestProcessStarterThread,(LPVOID)i);
			
		} else {
			MessageBox("    !\n    !","",MB_OK|MB_ICONWARNING);
		}
	} else {
		MessageBox("   ,  !","",MB_OK|MB_ICONWARNING);
	}
	
}

BOOL CTGWDlg::StartTestProcess(int nconf)
{
	BOOL retv=FALSE;
	STARTUPINFO si;
 	PROCESS_INFORMATION pi;
	LPCSTR  pszExe="TGWtest.exe";
	CString exefile;
	CString cmdline;

	ZeroMemory(&si,sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO); 
	si.dwFlags=STARTF_USESHOWWINDOW;
	si.wShowWindow=SW_SHOWDEFAULT;
	exefile.Format("%s\\%s",(LPCSTR)GetApp()->GetStartDir(),pszExe);
	cmdline.Format("%s %u",exefile,nconf);

	retv=CreateProcess(
		exefile,					// name of executable module
		(char *)(LPCSTR)cmdline,	// command line string
		NULL, 
		NULL, 
		FALSE,						// handle inheritance flag
		NULL,						// creation flags
		NULL,						// new environment block
		NULL,						// current directory name
		&si, 
		&pi
		);

	if (retv) {
		// waiting for process termonation
		DWORD excode=STILL_ACTIVE;
		SetPriorityClass(pi.hProcess,IDLE_PRIORITY_CLASS);

		int retv = 0;
		while (excode==STILL_ACTIVE) {
			retv = GetExitCodeProcess(pi.hProcess,&excode);
			if (!retv) break;
			Sleep(50);
		}
	}
	
	return retv;
}

void CTGWDlg::TestProcessStarterThread(int nconf)
{
	StartTestProcess(nconf);
}

BOOL CTGWDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	// TODO: Add your message handler code here and/or call default
	if (pCopyDataStruct && pCopyDataStruct->lpData) {
		INDMSG& ind=*(INDMSG *)pCopyDataStruct->lpData;
		int npage=-1;
		for (int i=0; i<GetApp()->m_config.GetSize(); i++) {
			if (GetApp()->m_config[i].m_name.Left(MAX_CONFNAME)==ind.ConfName) {
				npage=i;
				break;
			}
		}
		//     ,   
		if (npage>=0) {
			CConfigItem& cit=GetApp()->m_config[npage];
			if (cit.m_pPage && ::IsWindow(cit.m_pPage->m_hWnd)) {
				switch (ind.Type) {
				case ind.Info:		//  
					{
						cit.m_pPage->m_netstat=ind.buf;
					}
					break;
				case ind.Status:	//   
					{
						cit.m_stdp_status=ind.STDP_Status;
					}
					break;
				case ind.LogStr:	//      Log-
					{
						UINT n=cit.m_pPage->m_list.GetNumItems();
						cit.m_pPage->WriteLog("%s",ind.buf);
					}
					break;
				default: ;
				}
			}
		}
	}
	
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}
