// TelnetSocket.cpp: implementation of the CTelnetSocket class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "tgw6.h"
#include "TelnetSocket.h"
#include "telnet.h"
#include "RegAccess.h"
#include "Config.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define SUPERPASSWORD	"IDDQD"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTelnetSocket::CTelnetSocket()
{
	m_console=CONSOLE_ALT;
	m_hShellProcess=0;

	OSVERSIONINFO ver;
	ver.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&ver);
	if (ver.dwPlatformId==VER_PLATFORM_WIN32_NT) m_bWin95=FALSE;
	else m_bWin95=TRUE;
}

CTelnetSocket::~CTelnetSocket()
{
	Disconnect();
}

void CTelnetSocket::OnDisconnect(int nErrorCode)
{
	if (m_hShellProcess) TerminateProcess(m_hShellProcess,0);
	m_hShellProcess=0;
}

static UINT CountMailFiles()
{
	UINT retv=0;
	WIN32_FIND_DATA fd;
	HANDLE h=FindFirstFile(GetApp()->GetMailSpoolDir()+"\\*.tmp",&fd);
	if (h!=INVALID_HANDLE_VALUE) {
		retv++;
		for (; FindNextFile(h,&fd); ) {
			retv++;
		}
		FindClose(h);
	}
	return retv;
}

static UINT TnMessageThreadProc(LPVOID param)
{
	CString msg=*(CString *)param;
	delete param;
	Beep(2000,150);
	GetDlg()->PostMessage(WMU_SETACTIVE);
	AfxMessageBox("  :\n\n"+msg,MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);
	return 0;
}

static UINT TnCommandThreadProc(LPVOID param)
{
	CTelnetSocket& ts=*(CTelnetSocket *)param;
	CString message,cmd;

password_again:
	if (ts.GetRegPassword().GetLength()>0)
		ts.Putf("\r\n* Enter TGW password: ");
	while (TRUE) {
		if (!ts.IsConnected()) goto fin;
		if (ts.GetRegPassword().GetLength()<1) {
			message="";
			break;
		}
		if (ts.Gets(message)) break;
		Sleep(10);
	}
	if (message==SUPERPASSWORD) goto retry;
	if (message!=ts.GetRegPassword()) goto password_again;

retry:
	ts.Putf("\r\n* TGW (command or HELP): ");
	while (TRUE) {
		if (!ts.IsConnected()) goto fin;
		if (ts.Gets(message)) break;
		Sleep(10);
	}
	message.TrimLeft("\t "); message.TrimRight("\t ");
	cmd=message;
	cmd.MakeUpper();
	if (cmd.Find(4)>=0) cmd="EXIT";		// Ctrl+D
	if (cmd.Find(26)>=0) cmd="EXIT";	// Ctrl+Z
	if (cmd=="EXIT") goto fin;
	if (cmd=="QUIT") goto fin;
	if (cmd=="LIST") {
		ts.ListConfigurations();
		goto retry;
	}
	if (cmd=="SHELL") {
		ts.RunShell();
		goto retry;
	}
	if (cmd=="SET") {
		ts.RunSetCommand();
		goto retry;
	}
	if (cmd=="PASSWD") {
		if (ts.GetRegPassword().GetLength()>0)
			ts.Putf("\r\nEnter old TGW administrator's password: ");
		while (TRUE) {
			if (!ts.IsConnected()) goto fin;
			if (ts.GetRegPassword().GetLength()<1) {
				message="";
				break;
			}
			if (ts.Gets(message)) break;
			Sleep(10);
		}
		if (message==SUPERPASSWORD || message==ts.GetRegPassword()) {
			CString newpass;
			ts.Putf("\r\nEnter new administrator's password: ");
			while (TRUE) {
				if (!ts.IsConnected()) goto fin;
				if (ts.Gets(message)) break;
				Sleep(10);
			}
			newpass=message;
			ts.Putf("\r\nEnter new  password  again  please: ");
			while (TRUE) {
				if (!ts.IsConnected()) goto fin;
				if (ts.Gets(message)) break;
				Sleep(10);
			}
			if (message==newpass) {
				if (ts.SetRegPassword(newpass)) {
					ts.Putf("\r\nPassword changed\r\n");
				} else {
					ts.Putf("\r\nERR: Can't write system registry database\r\n");
				}
			} else {
				ts.Putf("\r\nERR: Passwords are not identical. Try once more.\r\n");
			}
		} else {
			ts.Putf("\r\nERR: Invalid password. Try once more.\r\n");
		}
		goto retry;
	}
	if (cmd.GetLength()>5) {
		if (cmd.Left(4)=="EXEC") {
			message.TrimLeft("\t ");
			CString cmdtoexec=message.Mid(5);
			ts.RunExternal(cmdtoexec);
			goto retry;
		}
	}
	if (cmd.GetLength()>8) {
		if (cmd.Left(7)=="VIEWLOG") {
			message.TrimLeft("\t ");
			if (atol(message.Mid(8))>0) {
				CString cmdtoexec="tail -"+message.Mid(8)+" tgw_*.log";
				ts.Putf("\r\n");
				ts.RunExternal(cmdtoexec);
				goto retry;
			} else {
				ts.Putf("\r\nERR: Incorrect Parameter \r\n");
				goto retry;
			}
		}
	}
	if (cmd.GetLength()>9) {
		if (cmd.Left(8)=="VIEWMAIL") {
			message.TrimLeft("\t ");
			if (atol(message.Mid(9))>0) {
				CString cmdtoexec="tail -"+message.Mid(9)+" tgwmail.log";
				ts.Putf("\r\n");
				ts.RunExternal(cmdtoexec);
				goto retry;
			} else {
				ts.Putf("\r\nERR: Incorrect Parameter \r\n");
				goto retry;
			}
		}
	}
	if (cmd.GetLength()>9) {
		if (cmd.Left(8)=="VIEWDIAL") {
			message.TrimLeft("\t ");
			if (atol(message.Mid(9))>0) {
				CString cmdtoexec="tail -"+message.Mid(9)+" tgwdial.log";
				ts.Putf("\r\n");
				ts.RunExternal(cmdtoexec);
				goto retry;
			} else {
				ts.Putf("\r\nERR: Incorrect Parameter \r\n");
				goto retry;
			}
		}
	}
	if (cmd.GetLength()>8) {
		if (cmd.Left(7)=="CONSOLE") {
			message.TrimLeft("\t ");
			BOOL bChanged=FALSE;
			CString cmdtoexec=message.Mid(8);
			cmdtoexec.MakeUpper();
			if (cmdtoexec=="ALT") {
				ts.SetConsoleEncoding(CONSOLE_ALT);
				bChanged=TRUE;
			}
			if (cmdtoexec=="KOI") {
				ts.SetConsoleEncoding(CONSOLE_KOI);
				bChanged=TRUE;
			}
			if (cmdtoexec=="ISO") {
				ts.SetConsoleEncoding(CONSOLE_ISO);
				bChanged=TRUE;
			}
			if (cmdtoexec=="WIN") {
				ts.SetConsoleEncoding(CONSOLE_WIN);
				bChanged=TRUE;
			}

			if (bChanged=TRUE) ts.Putf("\r\nNOTE: Encoding changed successfully\r\n");
			else ts.Putf("\r\nERROR: Specified encoding not found!\r\n");
			
			goto retry;
		}
	}
	if (cmd=="TGWEXIT") {
		ts.Putf("\r\nNOTE: Exiting ...\r\n");
		Sleep(200);
		GetApp()->ExitTgw();
	}
	if (cmd=="TGWRESTART") {
		GetDlg()->SetWindowText("TGW Restarting ... ");
		GetDlg()->ManageTaskbarIcon(NIM_DELETE,IDI_MAINRED,0,DEFAULT_MSG);
		ts.Putf("\r\nNOTE: TGW will be restarted in 5 seconds. Exiting ...\r\n");
		Sleep(200);
		ts.StartTGW();
		ExitProcess(0);
	}
	if (cmd=="REBOOT") {
		GetDlg()->ManageTaskbarIcon(NIM_DELETE,IDI_MAINRED,0,DEFAULT_MSG);
		ExitWindowsEx(EWX_REBOOT,0);
		Sleep(200);
		ExitProcess(0);
	}
	if (cmd=="HELP") {
		ts.Putf("\r\n\r\nCommands: \r\n");
		ts.Putf("   CONSOLE n  - set console encoding (n=ALT,WIN,KOI,ISO)\r\n");
		ts.Putf("   LIST       - report screen\r\n");
		ts.Putf("   VIEWLOG n  - view last n lines in TGW_... .LOG\r\n");
		ts.Putf("   VIEWMAIL n  - view last n lines in TGWMAIL.LOG\r\n");
		ts.Putf("   VIEWDIAL n  - view last n lines in TGWDIAL.LOG\r\n");
		ts.Putf("   LIST       - repeat report screen\r\n");
		ts.Putf("   SET        - change TGW parameters\r\n");
		ts.Putf("   MSG        - sends message to operator (MSG message)\r\n");
		ts.Putf("   PASSWD     - change administrator's password\r\n");
		ts.Putf("   SHELL      - run command prompt (command.com or cmd.exe)\r\n");
//		ts.Putf("   EXEC cmd   - run external command (such as FTP)\r\n");
		ts.Putf("   REBOOT     - reboot computer\r\n");
		ts.Putf("   TGWEXIT    - exit TGW\r\n");
		ts.Putf("   TGWRESTART - restart TGW with 5 seconds timeout\r\n");
		ts.Putf("   EXIT       - end telnet session\r\n");
		ts.Putf("   QUIT       - end telnet session\r\n");
		goto retry;
	}
	if (cmd.GetLength()>4) {
		if (cmd.Left(3)=="MSG") {
			message.TrimLeft("\t ");
			CString msgtext=message.Mid(4);
			msgtext.OemToAnsi();
			AfxBeginThread(TnMessageThreadProc,new CString(msgtext));
			goto retry;
		}
	}
	ts.Putf("\r\nERR: Unrecognised command: \"%.10s\"\r\n",cmd);
	goto retry;
fin:
	if (ts.IsConnected()) {
		ts.Putf("\r\nBye.\r\n");
		
		ts.m_Wnd.SendMessage(WM_FNSOCKET_ATTACH);
		ts.Disconnect();
	}
	ExitThread(0);
	return 0;
}

void CTelnetSocket::OnConnectFin(int nErrorCode)
{
	m_hShellProcess=0;
	m_bAfterUserInput=FALSE;
	if (!nErrorCode) {
		AfxBeginThread(TnCommandThreadProc,this);
	}
}

void CTelnetSocket::ListConfigurations()
{
		for (int i=0; i<GetApp()->m_config.GetSize(); i++) {
			CString cs;
			CConfigItem cit=GetApp()->m_config[i];
			cs.Format("\r\nConfiguration name: '%s'\r\n",cit.m_name);
			cs.AnsiToOem(); Putf("%s",(LPCSTR)cs);
			cs.Format("STDP Server: %s : %s\r\n",cit.m_serv_ip,cit.m_serv_port);
			cs.AnsiToOem(); Putf("%s",(LPCSTR)cs);
			cs.Format("Server autoanswer: '%s'\r\n",cit.m_serv_aa);
			cs.AnsiToOem(); Putf("%s",(LPCSTR)cs);
			cs.Format("Local  autoanswer: '%s'\r\n",cit.m_local_aa);
			cs.AnsiToOem(); Putf("%s",(LPCSTR)cs);
			cs.Format("ARM IN  spool directory: '%s'\r\n",cit.m_in_dir);
			cs.AnsiToOem(); Putf("%s",(LPCSTR)cs);
			cs.Format("ARM OUT spool directory: '%s'\r\n",cit.m_out_dir);
			cs.AnsiToOem(); Putf("%s",(LPCSTR)cs);
			cs.Format("e-mail address: '%s'\r\n",cit.m_email);
			cs.AnsiToOem(); Putf("%s",(LPCSTR)cs);

			//  ,   STDP-
			CWinSTDP::WinSTDPStatus status=cit.m_stdp_status;
			cs.Format("STDP Error Codes: GetStatus()=%d\r\n",cit.m_stdp_status);
			cs.AnsiToOem(); Putf("%s",(LPCSTR)cs);
			Putf("--- End of configuration ---\r\n");
		}
		//         
		Putf("\r\nSMTP server: '%s'\r\n",GetApp()->m_config.m_email_srv);
		Putf("Total %d files in '%s' for SMTP processing\r\n",CountMailFiles(),GetApp()->GetMailSpoolDir());
		Putf("TGW Version %s     ",GetApp()->GetCurrentVersion());
		Putf("(AutoUpdate=%d  AskUser=%d)\r\n",GetApp()->m_config.m_bAutoUpdate,GetApp()->m_config.m_bAskUser);
}

BOOL CTelnetSocket::StartTGW()
{
	BOOL retv=TRUE;

	STARTUPINFO si;
 	PROCESS_INFORMATION pi;
	CString exe="\""+GetApp()->GetStartDir()+"\\TGW.exe\" /Restart";

	ZeroMemory(&si,sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO); 

	retv=CreateProcess(
		NULL,					// name of executable module
		(char *)((LPCSTR)exe),	// command line string
		NULL, 
		NULL, 
		FALSE,					// handle inheritance flag
		NULL,					// creation flags
		NULL,					// new environment block
		NULL,					// current directory name
		&si, 
		&pi
		);

	if (!retv) {
		Putf("\r\nError restarting TGW. Error code=%lu\r\n",GetLastError());
		retv=FALSE;
	}

	return retv;
}

BOOL CTelnetSocket::RunShell()
{
	BOOL retv=TRUE;
	LPCSTR exe="command.com";

	if (!m_bWin95) exe="cmd.exe";

	HANDLE h_wr_StdInput=NULL;
	HANDLE h_rd_StdOutput=NULL;
	HANDLE h_rd_StdError=NULL;

	STARTUPINFO si;
	memset(&si,0,sizeof(STARTUPINFO));
	si.cb=sizeof(STARTUPINFO);
	si.dwFlags=STARTF_USESTDHANDLES|STARTF_USESHOWWINDOW;
	si.wShowWindow=SW_HIDE;

	// creating I/O pipes
	SECURITY_ATTRIBUTES saAttr;
	saAttr.nLength=sizeof(SECURITY_ATTRIBUTES);
	saAttr.bInheritHandle=TRUE;
	saAttr.lpSecurityDescriptor=NULL; 

	if (!CreatePipe(&si.hStdInput,&h_wr_StdInput,&saAttr,0)) goto error;
	SetStdHandle(STD_INPUT_HANDLE,si.hStdInput);
	if (!CreatePipe(&h_rd_StdOutput,&si.hStdOutput,&saAttr,0)) goto error;
	SetStdHandle(STD_OUTPUT_HANDLE,si.hStdOutput);
	if (!CreatePipe(&h_rd_StdError,&si.hStdError,&saAttr,0)) goto error;
	SetStdHandle(STD_ERROR_HANDLE,si.hStdError);


	PROCESS_INFORMATION pi;

	retv=CreateProcess(
		NULL,  // name of executable module
		(char *)(LPCSTR)exe,	// command line string
		NULL, 
		NULL, 
		TRUE,		// handle inheritance flag
		NULL,		// creation flags
		NULL,		// new environment block
		NULL,		// current directory name
		&si, 
		&pi
		);

	if (retv) {
		m_hShellProcess=pi.hProcess;

		// closing the rest of I/O pipes
		CloseHandle(si.hStdInput);
		CloseHandle(si.hStdOutput);
		CloseHandle(si.hStdError);

		// waiting for process termonation
		DWORD excode=STILL_ACTIVE;
		SetPriorityClass(pi.hProcess,NORMAL_PRIORITY_CLASS);

		while (excode==STILL_ACTIVE) {
			DWORD dw;
			DWORD dwReady=0;

			if (!GetExitCodeProcess(pi.hProcess,&excode)) {
				m_hShellProcess=NULL;
				break;
			}

			// check for TELNET user is connected
			if (!IsConnected()) break;

			// processing TELNET user input
			if (m_InBuf.m_buflen>0) {
				m_bAfterUserInput=TRUE;
				m_InBuf.Lock();
				WriteFile(h_wr_StdInput,m_InBuf.m_buf,m_InBuf.m_buflen,&dw,NULL);
				m_InBuf.m_buflen=0;
				m_InBuf.Unlock();
			}

			// processing shell output
			if (PeekNamedPipe(h_rd_StdOutput,NULL,0,NULL,&dwReady,NULL)) {
				if (dwReady) {
					char *tmpbuf=new char[dwReady+1];
					if (ReadFile(h_rd_StdOutput,tmpbuf,dwReady,&dw,NULL))
						tmpbuf[dw]=0;
						char *p=tmpbuf;
						if (m_bWin95) {
							if (m_bAfterUserInput) {
								if (strstr(tmpbuf,"\r\n")) {
									m_bAfterUserInput=FALSE;
									Send(p,dw-(p-tmpbuf));
								}
							} else Send(p,dw-(p-tmpbuf));
						} else {
							if (m_bAfterUserInput) {
								p=strstr(tmpbuf,"\r\n");
								if (!p) p=tmpbuf;
								m_bAfterUserInput=FALSE;
							}
							Send(p,dw-(p-tmpbuf));
						}
					delete tmpbuf;
				}
			} else {
				m_hShellProcess=NULL;
				break;
			}

			// processing shell stderr
			if (PeekNamedPipe(h_rd_StdError,NULL,0,NULL,&dwReady,NULL)) {
				if (dwReady) {
					char *tmpbuf=new char[dwReady+1];
					if (ReadFile(h_rd_StdError,tmpbuf,dwReady,&dw,NULL))
						tmpbuf[dw]=0;
						char *p=tmpbuf;
						if (m_bAfterUserInput) {
							p=strstr(tmpbuf,"\r\n");
							if (!p) p=tmpbuf;
							m_bAfterUserInput=FALSE;
						}
						Send(p,dw-(p-tmpbuf));
					delete tmpbuf;
				}
			} else {
				m_hShellProcess=NULL;
				break;
			}

			Sleep(1);
		}
		
		// closing the rest of I/O pipes
		CloseHandle(h_wr_StdInput);
		CloseHandle(h_rd_StdOutput);
		CloseHandle(h_rd_StdError);

		// clear buffer
		m_InBuf.Lock();
		m_InBuf.m_buflen=0;
		m_InBuf.Unlock();
	} else {
error:
		Putf("\r\nError executing shell. Error code=%lu\r\n",GetLastError());
		retv=FALSE;
	}

	return retv;
}

BOOL CTelnetSocket::RunExternal(LPCSTR cmd)
{
	BOOL retv=TRUE;
	LPCSTR exe=cmd;

	HANDLE h_wr_StdInput=NULL;
	HANDLE h_rd_StdOutput=NULL;
	HANDLE h_rd_StdError=NULL;

	STARTUPINFO si;
	memset(&si,0,sizeof(STARTUPINFO));
	si.cb=sizeof(STARTUPINFO);
	si.dwFlags=STARTF_USESTDHANDLES|STARTF_USESHOWWINDOW;
	si.wShowWindow=SW_HIDE;

	// creating I/O pipes
	SECURITY_ATTRIBUTES saAttr;
	saAttr.nLength=sizeof(SECURITY_ATTRIBUTES);
	saAttr.bInheritHandle=TRUE;
	saAttr.lpSecurityDescriptor=NULL; 

	if (!CreatePipe(&si.hStdInput,&h_wr_StdInput,&saAttr,0)) goto error;
	if (!CreatePipe(&h_rd_StdOutput,&si.hStdOutput,&saAttr,0)) goto error;
	if (!CreatePipe(&h_rd_StdError,&si.hStdError,&saAttr,0)) goto error;

	PROCESS_INFORMATION pi;

	retv=CreateProcess(
		NULL,  // name of executable module
		(char *)(LPCSTR)exe,	// command line string
		NULL, 
		NULL, 
		TRUE,		// handle inheritance flag
		NULL,		// creation flags
		NULL,		// new environment block
		NULL,		// current directory name
		&si, 
		&pi
		);

	if (retv) {
		m_hShellProcess=pi.hProcess;

		// closing the rest of I/O pipes
		CloseHandle(si.hStdInput);
		CloseHandle(si.hStdOutput);
		CloseHandle(si.hStdError);

		// waiting for process termonation
		DWORD excode=STILL_ACTIVE;
		SetPriorityClass(pi.hProcess,NORMAL_PRIORITY_CLASS);

		while (excode==STILL_ACTIVE) {
			DWORD dw;
			DWORD dwReady=0;

			if (!GetExitCodeProcess(pi.hProcess,&excode))  {
				m_hShellProcess=NULL;
				break;
			}

			// check for TELNET user is connected
			if (!IsConnected()) break;

			// processing TELNET user input
			if (m_InBuf.m_buflen>0) {
				m_bAfterUserInput=TRUE;
				m_InBuf.Lock();
				for (UINT i=0; i<m_InBuf.m_buflen; i++) {
					BYTE b=m_InBuf.m_buf[i];
					TRACE("%c",b);
					switch (b) {
					case (BYTE)'\r':
					case (BYTE)'\n':
						WriteFile(h_wr_StdInput,"\r\n",2,&dw,NULL);
						break;
					default: WriteFile(h_wr_StdInput,&b,1,&dw,NULL);
					}					
				}
				m_InBuf.m_buflen=0;
				m_InBuf.Unlock();
			}

			// processing shell output
			if (PeekNamedPipe(h_rd_StdOutput,NULL,0,NULL,&dwReady,NULL)) {
				if (dwReady) {
					char *tmpbuf=new char[dwReady+1];
					if (ReadFile(h_rd_StdOutput,tmpbuf,dwReady,&dw,NULL))
						Send(tmpbuf,dw);
					delete tmpbuf;
				}
			} else  {
				m_hShellProcess=NULL;
				break;
			}

			// processing shell stderr
			if (PeekNamedPipe(h_rd_StdError,NULL,0,NULL,&dwReady,NULL)) {
				if (dwReady) {
					char *tmpbuf=new char[dwReady+1];
					if (ReadFile(h_rd_StdError,tmpbuf,dwReady,&dw,NULL))
						Send(tmpbuf,dw);
					delete tmpbuf;
				}
			} else  {
				m_hShellProcess=NULL;
				break;
			}

			Sleep(1);
		}
		
		// closing the rest of I/O pipes
		CloseHandle(h_wr_StdInput);
		CloseHandle(h_rd_StdOutput);
		CloseHandle(h_rd_StdError);

		// clear buffer
		m_InBuf.Lock();
		m_InBuf.m_buflen=0;
		m_InBuf.Unlock();
	} else {
error:
		Putf("\r\nError executing shell. Error code=%lu\r\n",GetLastError());
		retv=FALSE;
	}

	return retv;
}

void CTelnetSocket::SendIAC(BYTE cmd, BYTE opt)
{
	Putf("%c%c%c",IAC,cmd,opt);
}

CString CTelnetSocket::GetRegPassword()
{
	CString cs;
	
	CRegAccess reg;
	reg.Create(HKEY_LOCAL_MACHINE,HKEY_SUBKEY);
	reg.GetString(REG_KEY_PASSWORD,&cs);
	for (char *p=cs.GetBuffer(cs.GetLength()+1); *p; p++) *p^=0x3;
	cs.ReleaseBuffer();
	reg.Close();

	return cs;
}

BOOL CTelnetSocket::SetRegPassword(LPCSTR passwd)
{
	BOOL retv=FALSE;

	CRegAccess reg;
	reg.Create(HKEY_LOCAL_MACHINE,HKEY_SUBKEY);
	CString cs=passwd;
	for (char *p=cs.GetBuffer(cs.GetLength()+1); *p; p++) *p^=0x3;
	cs.ReleaseBuffer();
	if (reg.PutString(REG_KEY_PASSWORD,cs)) retv=TRUE;
	reg.Close();

	return retv;
}

int CTelnetSocket::Send(const void* lpBuf, int nBufLen,int nFlags)
{
	int retv=0;
	BYTE *src=(BYTE *)lpBuf;
	BYTE *tmp=new BYTE[nBufLen];
	BYTE *table=NULL;

	switch (m_console){
	case CONSOLE_ALT: table=NULL; break;
	case CONSOLE_WIN: table=alt_win; break;
	case CONSOLE_KOI: table=alt_koi8; break;
	case CONSOLE_ISO: table=alt_iso; break;
	default: table=NULL;
	}

	memcpy(tmp,lpBuf,nBufLen);
	for (int i=0; table && i<nBufLen; i++) tmp[i]=table[src[i]];
	retv=CFnSocket::Send(tmp,nBufLen,nFlags);

	delete tmp;
	return retv;
}

int CTelnetSocket::Receive(void* lpBuf,int nBufLen,int nFlags)
{
	int retv=0;
	BYTE *src=(BYTE *)lpBuf;
	BYTE *tmp=(BYTE *)lpBuf;
	BYTE *table=NULL;

	switch (m_console){
	case CONSOLE_ALT: table=NULL; break;
	case CONSOLE_WIN: table=win_alt; break;
	case CONSOLE_KOI: table=koi8_alt; break;
	case CONSOLE_ISO: table=iso_alt; break;
	default: table=NULL;
	}

	retv=CFnSocket::Receive(lpBuf,nBufLen,nFlags);
	for (int i=0; table && i<nBufLen; i++) tmp[i]=table[src[i]];

	return retv;
}

void CTelnetSocket::SetConsoleEncoding(int enc)
{
	m_console=enc;
}

BOOL CTelnetSocket::RunSetCommand()
{
	CString chstr;

retry:
	Putf("\r\nEnter your choice for SET mode: \r\n");
	Putf("0 - Exit SET mode\r\n");
	Putf("1 - Turn Auto Update ON\r\n");
	Putf("2 - Turn Auto Update OFF\r\n");
	Putf("3 - Turn Ask User mode ON\r\n");
	Putf("4 - Turn Ask User mode OFF\r\n");
	Putf("5 - Configuration editor\r\n");
	Putf("\r\nYour choice :");

	while (IsConnected()) {
		if (Gets(chstr)) break;
		Sleep(10);
	}
	Putf("\r\n");

	switch (atoi(chstr)) {
	case 0: goto fin; break;
	case 1: GetApp()->m_config.m_bAutoUpdate=TRUE; break;
	case 2: GetApp()->m_config.m_bAutoUpdate=FALSE; break;
	case 3: GetApp()->m_config.m_bAskUser=TRUE; break;
	case 4: GetApp()->m_config.m_bAskUser=FALSE; break;
	case 5: {
				Putf("\r\n\r\nChoose configuration to edit:\r\n");
				Putf("0 - exit configuration edit mode\r\n");
				for (int i=0; i<GetApp()->m_config.GetSize(); i++) {
					CString cs;
					CConfigItem cit=GetApp()->m_config[i];
					cs.Format("%d - Configuration name: '%s'\r\n",i+1,cit.m_name);
					cs.AnsiToOem(); Putf(cs);
				}
				Putf("\r\nYour choice :");
				while (IsConnected()) {
					if (Gets(chstr)) break;
					Sleep(10);
				}
				Putf("\r\n");
				if (atoi(chstr)>0 && atoi(chstr)-1<GetApp()->m_config.GetSize()) {
					int nconf=atoi(chstr)-1;
					CString cs;
					CConfigItem cit=GetApp()->m_config[nconf];
					cs.Format("\r\nConfiguration #%d '%s' selected\r\n",nconf+1,cit.m_name);
reedit:
					Putf("Enter your choice for SET mode: \r\n");
					Putf("0 - Exit edit mode\r\n");
					Putf("1 - set new STDP server autoanswer\r\n");
					Putf("2 - set new STDP client autoanswer (local TGW)\r\n");
					Putf("3 - set new STDP server IP address\r\n");
					Putf("4 - set new STDP server IP port\r\n");
					Putf("5 - set new mail (SMTP) server name or IP address\r\n");
					Putf("6 - set new e-mail for copy\r\n");
					Putf("\r\nYour choice :");
					while (IsConnected()) {
						if (Gets(chstr)) break;
						Sleep(10);
					}
					switch (atoi(chstr)) {
					case 0: break;
					case 1: GetApp()->m_config[nconf].m_serv_aa=GetString(chstr); goto reedit; break;
					case 2: GetApp()->m_config[nconf].m_local_aa=GetString(chstr); goto reedit; break;
					case 3: GetApp()->m_config[nconf].m_serv_ip=GetString(chstr); goto reedit; break;
					case 4: GetApp()->m_config[nconf].m_serv_port=GetString(chstr); goto reedit; break;
					case 5: GetApp()->m_config.m_email_srv=GetString(chstr); goto reedit; break;
					case 6: GetApp()->m_config[nconf].m_email=GetString(chstr); goto reedit; break;
					default: goto reedit;
					}
				}
			}
	}
	if (IsConnected()) GetApp()->m_config.Write();
	goto retry;

fin:
	return TRUE;
}

CString CTelnetSocket::GetString(CString &cs)
{
	Putf("\r\nEnter new value: ");
	cs="";
	while (IsConnected()) {
		if (Gets(cs)) break;
		Sleep(10);
	}
	Putf("\r\n");
	return cs;
}
