// WinSTDP.h: interface for the CWinSTDP class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WSTDP_H__1AEFDC05_A76D_4118_805B_D27B87C0F7A3__INCLUDED_)
#define AFX_WSTDP_H__1AEFDC05_A76D_4118_805B_D27B87C0F7A3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FnSocket.h"
#include "table.h"
#include "Message.h"

#include <afxtempl.h>

#define MAX_ACK_WAIT_TIME 1000*180
#define MAX_RECEIVE_TIMEOUT	1000*60
#define SEND_TESTIU_TIMEOUT 1000*15

class CWinSTDP : public CFnSocket  
{
public:
	UINT m_ncit;				//   
	enum WinSTDPStatus {
		CONN_OK=0,
        CONN_HIDER_ERR=1,
        CONN_UNK_CLIENT=2,
        CONN_UNK_SERVER=3,
        CONN_REP_CONNECT=4,
        CONN_CHAN_CLOSED=5,
        CONN_ACCESS=6,
        CONN_NOT_SET=7,
		CONN_CORRUPT=8
	};
private:
	CString m_laa;				// local AA
	CString m_raa;				// remote AA
	CString m_lip;				// local IP
	CString m_rip;				// remote IP
	UINT	m_port;				// IP port
	DWORD	m_lrecvtime;
	DWORD	m_lsendtime;
	WinSTDPStatus	m_stat;		// current status
	CArray<CMessage,CMessage> m_InQueue;		// input queue
	CArray<CMessage,CMessage> m_OutQueue;		// ouput queue
	CCriticalSection m_CrsIn;
	CCriticalSection m_CrsOut;

	virtual void OnDisconnect(int nErrorCode);
	virtual void OnConnectFin(int nErrorCode);
	virtual void OnError(LPCSTR pszComment);
	virtual int Send(const void* lpBuf, int nBufLen,int nFlags);
	virtual int Receive(void* lpBuf, int nBufLen,int nFlags);
	
	unsigned GetMessageSize(void);
	void TransMem(void * mem,const void * tab, UINT len);
	UINT Hex2Int(LPCSTR str,UINT len);
	UINT Dec2Int(LPCSTR str,UINT len);
	static void Scheduler(CWinSTDP *);
	unsigned GetIUSize(void);
	int GetIUType(void);
	void DelIU(void) {m_InBuf.Del(GetIUSize());}
public:
	CString GetStatusText();
	UINT GetOutQueueSize();
	static void ReconnectThread(CWinSTDP& stdp);
	void PrintLogWin(UINT ncit, LPCSTR fmt, ...);
	BOOL volatile m_bReconnectInProgress;
	int m_nconf;
	WinSTDPStatus GetStatus();
	BOOL HaveMessage(void);
	CString GetMessage(void);
	BOOL PutMessage(LPCSTR msg);
	void Connect(LPCSTR ip,UINT port,LPCSTR raa,LPCSTR laa,int nconf);

	CWinSTDP();
	virtual ~CWinSTDP();

private:
	void SendTestIU(void);
	void CheckTimeout(void);
	CMessage * FindMessage(LPCSTR kvn_str);
	void CheckQueue(void);
	void SendIU(void);
	void ParseIU();
private:
	virtual void Reconnect();
};

#endif // !defined(AFX_WSTDP_H__1AEFDC05_A76D_4118_805B_D27B87C0F7A3__INCLUDED_)
