#if !defined (__STDP_IE_HCC__)
#define __STDP_IE_HCC__


/*
  $Log: stdp_ie.h,v $
  Revision 1.2  1999/03/02 14:44:01  avl
  Changed recoding table TODKOI from POST_ASCII_DKOI to KOI_TO_DKOI
  new table is very GOOD !!!

  Revision 1.1.1.1  1999/02/16 13:22:09  andrew
  STDP portable sources

  Revision 1.3  1998/12/07 07:55:38  avl
   

  Revision 1.2  1998/12/07 07:54:32  avl
  *** empty log message ***

*/

#ifndef WIN32
const char STDP_IE_REVISION[] =
    "REVISION: $Id: stdp_ie.h,v 1.2 1999/03/02 14:44:01 avl Exp $";
#endif

#ifndef uchar
typedef unsigned char uchar;
#endif

//#define TODKOI POST_ASCII_DKOI
#define TODKOI   KOI_TO_DKOI
#define TOASCII  POST_DKOI_ASCII


#define IE_STR_CON       "03"
#define IE_STR_CONANSW   "04"

//
//   
//

#define IE_CON       0x03
#define IE_CONANSW   0x04

#define IE_MSG       0x05
#define IE_MSGANSW   0x06

#define IE_DISCON    0x07

#define IE_TST       0x08
#define IE_TSTANSW   0x09

#define IE_WARN      0x0A


//
//    
//
struct FixHider {

    uchar    stdp [4];   //  "STDP" (16)
    uchar    h_len[3];   //   (16)
    uchar    v_len[8];   //    (16)
    uchar    type [2];   //   (16)
    
};

//
//  
//

typedef uchar STDAddr[13];

//
//    
//

//   
#define  CONCTL_GETAL (1<<8);

//     
#define  CONCTL_TLIM  (1);

//
//  :   
//
struct ConnHider : public FixHider {
    
    STDAddr  cli_addr;   //   (16)
    STDAddr  srv_addr;   //   (16)
    uchar    max_msg[3]; // 1 - 100 (10)  ????    (16)
    uchar    ctl    [2]; //   (16)
    
};

//
//      
//

//     
#define CONCODE_AL     (1<<8)
//      
#define CONCODE_TLIMT  (1)

//
//  :     
//
struct ConnAnswHider : public ConnHider {
    uchar    code[2];    //   (16)
};

//
//  :       
//                        .
struct STDAddrList {
    uchar    count[4];    // 1 - 2000 (10) ??    (16)
    STDAddr  list[1];     //    ()
};


//
//   
//

//    
#define MSGCTL_ANSW     (1<<8)
// ()    
#define MSGCTL_HASMSG   (1<<7)


//
//  
//

#define MSGATR_DEF       0x00
// 
#define MSGATR_SROCH    (1<<6)
//  
#define MSGATR_SSROCH   (2<<6)
// 
#define MSGATR_SLUZ     (3<<6)

//  (   )
#define MSGATR_BIN      (1<<5)
//      ( )
#define MSGATR_FULCOD   (1<<4)
//   ( )
#define MSGATR_VTOR     (1<<3)
//   (   )
#define MSGATR_SKF      (1)
//   ( )
#define MSGATR_SPF      (2)

//
//  : 
//
struct MsgHider : public FixHider {
    uchar    ctl[2];         //   (16)
    uchar    attr[2];        //           (16)
    STDAddr  from;           //   ()
    STDAddr  to;             //   ()
    uchar    msg_len[8];     //   (16)
    uchar    sndr_num[12];   //    (16)
};


//
//      
//

//  O.B.
#define MSGCODE_OK     (0x00)
//   
#define MSGCODE_ERRLEN (0x01)
//  
#define MSGCODE_NOSNDR (0x02)
//  
#define MSGCODE_NORCVR (0x03)
//    
#define MSGCODE_ERRQU  (0x04)

//
//  :   
//
struct MsgAnswHider : public MsgHider {
    uchar    code[2];        //   (16)
    uchar    rcvr_num[12];   //    (16)
};
//   
#define DSCCODE_ERRHDR   (0x01)
// 
#define DSCCODE_TIMEOUT  (0x02)
//  
#define DSCCODE_NOANSW   (0x03)
//  
#define DSCCODE_BYOPER   (0x04)

//
//  :   
//
struct DisconHider : public FixHider {
    STDAddr  from;    //   
    STDAddr  to;      // --||--
    uchar    code[2]; //    
};


//    (    )
#define TSTCTL_GETAL     (1<<7)

//
//  : 
//
struct TestHider : public FixHider {
    STDAddr  from;   //  ()
    STDAddr  to;     //  ()
    uchar    ctl[2]; //   (16)
};

//
//    
//

//  O.B.
#define TSTCODE_OK       (0x00)

//
//  :   
//
struct TestAnswHider : public TestHider {
    uchar    code[2]; //  
};


//
//    ""
//

//  
#define WARN_UNKNIE      (0x01)
//     
#define WARN_SUDIE       (0x02)

//
//  : 
//
struct WarnHider : public FixHider {
    STDAddr  from;
    STDAddr  to;
    uchar    code[2]; //  
};


extern unsigned char POST_ASCII_DKOI[256];
extern unsigned char POST_DKOI_ASCII[256];
extern unsigned char KOI_TO_DKOI[256];

#endif
