// TGWTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TGWTest.h"
#include "TGWTestDlg.h"
#include "../TGW/ConfigItem.h"
#include "../TGW/Config.h"

#define WMU_UPDATEDATA	(WM_USER+1)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTGWTestDlg dialog

CTGWTestDlg::CTGWTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTGWTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTGWTestDlg)
	m_answer = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bTesting=FALSE;
}

void CTGWTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTGWTestDlg)
	DDX_Control(pDX, IDC_TIMEOUT, m_timeout);
	DDX_Control(pDX, IDC_MSG, m_msg);
	DDX_Control(pDX, IDC_LITE, m_lite);
	DDX_Text(pDX, IDC_ANSWER, m_answer);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTGWTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTGWTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTGWTestDlg message handlers

BOOL CTGWTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_msg.SetWindowText("STD TEST");
	m_timeout.SetWindowText("30");
	GetDlgItem(IDOK)->EnableWindow(FALSE); //    
	m_lite.Open(IDA_LITE);
	m_lite.ShowWindow(SW_HIDE);

	int nconfig=atoi(__argv[1]);
	if (nconfig<0 || nconfig>=m_config.GetSize()) {
		Beep(3000,100);
		AfxMessageBox(" TGWtest.exe    !\n"
			"     TGW.exe",MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
		ExitProcess(0);
	}

	CWnd *pWnd=CWnd::FindWindow(NULL,"TGW  ");
	CenterWindow(pWnd);

	CConfigItem &cit=m_config[nconfig];
	SetWindowText(" STDP    '"+cit.m_name+"'");
	m_stdp.Connect(cit.m_serv_ip,atol(cit.m_serv_port),cit.m_serv_aa,cit.m_local_aa,nconfig);

	SetTimer(1,200,NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTGWTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTGWTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTGWTestDlg::OnOK() 
{
	// TODO: Add extra validation here
	m_bTesting=TRUE;
	
	//    
	CString msg;
	m_msg.GetWindowText(msg);
	//   
	if (m_stdp.GetStatus()==CWinSTDP::WinSTDPStatus::CONN_OK) {
		m_stdp.PutMessage(msg);
		m_lite.Seek(0);
		m_lite.Play(0,-1,-1);
		m_lite.ShowWindow(SW_SHOW);

		GetDlgItem(IDOK)->EnableWindow(FALSE);
		GetDlgItem(IDCANCEL)->EnableWindow(FALSE);

		//      
		AfxBeginThread((AFX_THREADPROC)WaitAnsThread,this);
	}
}

void CTGWTestDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (!m_bTesting) {
		if (m_stdp.GetStatus()==CWinSTDP::WinSTDPStatus::CONN_OK) {
			CString csa; GetDlgItem(IDC_ANSWER)->GetWindowText(csa);
			if (csa.Left(40)=="\r\n   STDP  ") {
				m_answer="";
				SendMessage(WMU_UPDATEDATA);
			}
			GetDlgItem(IDOK)->EnableWindow(TRUE);
		} else {
			m_answer="\r\n   STDP  "
				"\r\n  , ...\r\n\r\n"+
				m_stdp.GetStatusText();
			SendMessage(WMU_UPDATEDATA);
			GetDlgItem(IDOK)->EnableWindow(FALSE);
		}
	}
	if (!CWnd::FindWindow(NULL,"TGW  ")) ExitProcess(0);
	SetTimer(1,300,NULL);
}

void CTGWTestDlg::WaitAnsThread(CTGWTestDlg &dlg)
{
		BOOL found=FALSE;
		CString msg;
		CString cs; dlg.m_timeout.GetWindowText(cs); int maxtime=atoi(cs);
		if (maxtime<1) {maxtime=2; dlg.m_timeout.SetWindowText("1");}
		if (maxtime>120) {maxtime=120; dlg.m_timeout.SetWindowText("120");}

		DWORD stime=GetTickCount();

		for (int t=0; t<maxtime*10; t++) {
			//   
			dlg.m_answer.Format("  %4.1f ...",(maxtime*10-t)/10.);
			dlg.SendMessage(WMU_UPDATEDATA);

			//   
			if (dlg.m_stdp.HaveMessage()) {
				msg=dlg.m_stdp.GetMessage();
				found=TRUE; break;
			} else Sleep(50);
		}

		//   
		if (!found) {
			Beep(3000,300);
			dlg.m_answer="";
			dlg.SendMessage(WMU_UPDATEDATA);
		} else {
			Beep(5000,50);
			dlg.m_answer=msg;
			dlg.SendMessage(WMU_UPDATEDATA);
		}
		dlg.GetDlgItem(IDOK)->EnableWindow(TRUE);
		dlg.GetDlgItem(IDCANCEL)->EnableWindow(TRUE);
		dlg.m_lite.ShowWindow(SW_HIDE);
		dlg.m_bTesting=FALSE;
}

LRESULT CTGWTestDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (message==WMU_UPDATEDATA) {
		UpdateData(FALSE);
	}
	
	return CDialog::DefWindowProc(message, wParam, lParam);
}


void CTGWTestDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	ExitProcess(0);
	
	CDialog::OnCancel();
}
