// TGWconf.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TGWconf.h"
#include "../TGW/common.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static CStringArray * Synt(CStringArray *pArr,LPCSTR str,LPCSTR brk)
{
	char *nl,tmps[MAX_TMP_STR+1]; int ln;

	nl=strrchr(str,'\n'); if (nl) nl[0]=0;
	nl=strrchr(str,'\r'); if (nl) nl[0]=0;

	pArr->RemoveAll();
	for (LPCSTR p=str; str; ) {
		for (; strchr(brk,*p); p++,str++) ;
		p=strpbrk(p,brk);
		if (p) ln=(int)(p-str); else ln=strlen(str);
		strncpy(tmps,str,ln); tmps[ln]=0; str=p; 
		pArr->Add(tmps);
    }
	return pArr;
}

/////////////////////////////////////////////////////////////////////////////
// CTGWconfApp

BEGIN_MESSAGE_MAP(CTGWconfApp, CWinApp)
	//{{AFX_MSG_MAP(CTGWconfApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTGWconfApp construction

CTGWconfApp::CTGWconfApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTGWconfApp object

CTGWconfApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTGWconfApp initialization

BOOL CTGWconfApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	if (__argc<2) {
		Beep(3000,100);
		AfxMessageBox(" TGWconf.exe    !\n"
			"     TGW.exe",MB_OK|MB_ICONWARNING);
		ExitProcess(0);
	}
	m_nconfig=atoi(__argv[1]);
	if (m_nconfig<0 || (int)m_nconfig>=m_config.GetSize()) {
		Beep(3000,100);
		AfxMessageBox(" TGWconf.exe    !\n"
			"     TGW.exe",MB_OK|MB_ICONWARNING);
		ExitProcess(0);
	}

	//   
	CWnd *pWnd=CWnd::FindWindow(NULL,"TGW  ");
	if (!pWnd) ExitProcess(0);
	if (m_config[m_nconfig].m_disabled!="1") {
		INDMSG ind;
		ind.Type=ind.Status;
		strcpy(ind.ConfName,m_config[m_nconfig].m_name.Left(MAX_CONFNAME));
		ind.STDP_Status=CWinSTDP::WinSTDPStatus::CONN_NOT_SET;
		COPYDATASTRUCT cps;
		cps.dwData=0;
		cps.cbData=sizeof(INDMSG);
		cps.lpData=&ind;
		pWnd->SendMessage(WM_COPYDATA,0,(LPARAM)&cps);
	}

	srand((UINT)time(0));
	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return TRUE;
}

BOOL CTGWconfApp::SendMail(int ncit, LPCSTR msg, LPCSTR subject)
{
	CString mailfile,mailfiletmp;
	CConfigItem cit=m_config[ncit];

	if (cit.m_mailenabled!="1") return TRUE;

	cit.m_email.TrimLeft(" "); cit.m_email.TrimRight(" ");
	if (cit.m_email.GetLength()<1) return TRUE;
	
	m_config.m_email_srv.TrimLeft(" "); m_config.m_email_srv.TrimRight(" ");
	if (m_config.m_email_srv.GetLength()<1) return TRUE;

	//      
	TRY {
		CString cs;
		CTime ctime=CTime::GetCurrentTime();
		mailfile.Format("%s\\Mail-%01x-%08x-%08x-08%x.tmp",GetMailSpoolDir(),ncit,ctime.GetTime(),GetTickCount(),rand());
		mailfiletmp.Format("%s\\Mail-%01x-%08x-%08x-08%x.ren",GetMailSpoolDir(),ncit,ctime.GetTime(),GetTickCount(),rand());
		//  *.ren    
		CFile ft(mailfiletmp,CFile::modeWrite|CFile::modeCreate|CFile::shareExclusive);
		cs.Format("# == DO NOT EDIT! ( )\r\n");		cs.AnsiToOem(); ft.Write(cs,cs.GetLength());
		cs.Format("SERVER=%s\r\n",m_config.m_email_srv);		cs.AnsiToOem(); ft.Write(cs,cs.GetLength());
		cs.Format("PORT=%d\r\n",25);					cs.AnsiToOem(); ft.Write(cs,cs.GetLength());
		cs.Format("TO=%s\r\n",cit.m_email);				cs.AnsiToOem(); ft.Write(cs,cs.GetLength());
		cs.Format("FROM=%s\r\n","STDP_TGW");			cs.AnsiToOem(); ft.Write(cs,cs.GetLength());
		cs.Format("SUBJECT=%s\r\n",subject);			cs.AnsiToOem(); ft.Write(cs,cs.GetLength());
		cs.Format("# == TGW SIGNATURE\r\n");			cs.AnsiToOem(); ft.Write(cs,cs.GetLength());
		cs=msg;	ft.Write(cs,cs.GetLength());
		ft.Close();
	} CATCH(CFileException, e) {
		CString err=GetFileExceptionText(*e);
		//AfxMessageBox(" ren "+err);
		return FALSE;
	}
	END_CATCH
	
	//  *.ren   *.tmp     
	TRY {
		MoveFile(mailfiletmp,mailfile);
	} CATCH(CFileException, e) {
		CString err=GetFileExceptionText(*e);
		//AfxMessageBox(" ren "+err);
		TRY {
			DeleteFile(mailfiletmp);
		} CATCH(CFileException, e) {
			CString err=GetFileExceptionText(*e);
			//AfxMessageBox(" ren "+err);
		}
		END_CATCH
		return FALSE;
	}
	END_CATCH
	
	return TRUE;
}

CString CTGWconfApp::GetStartDir()
{
	CString retv=__argv[0];
	int i=retv.ReverseFind('\\');
	if (i>=0) retv=retv.Left(i);
	else retv=".";
	return retv;
}

CString CTGWconfApp::GetMailSpoolDir()
{
	return GetStartDir()+"\\TGWmail";
}

void CTGWconfApp::ProcessConf()
{
	CConfigItem& cit=m_config[m_nconfig];

	SetThreadPriority(THREAD_PRIORITY_LOWEST);

	HANDLE dh=FindFirstChangeNotification(cit.m_out_dir,FALSE,
		FILE_NOTIFY_CHANGE_FILE_NAME|FILE_NOTIFY_CHANGE_SIZE|FILE_NOTIFY_CHANGE_LAST_WRITE);

	if (dh==INVALID_HANDLE_VALUE) {
		CString cs;
		switch (GetLastError()) {
		case 2:	 cs.Format("     !\n"
					 " '%s'  \n !\n\n"
					 "   TGW  ",
					 cit.m_out_dir); break;
		default: cs.Format("     \n"
					 "spool-. GetLastError()=%d\n\n"
					 "   TGW  ",
					 GetLastError()); break;
		}
		AfxMessageBox(cs,MB_OK|MB_ICONWARNING);
		ExitProcess(255);
	} else {
		//   :     , 
		//     30 
		WaitForSingleObject(dh,3000u);
		ReadSpool();
	}
	FindCloseChangeNotification(dh);
}

void CTGWconfApp::ReadSpool()
{
	WIN32_FIND_DATA fd;
	CConfigItem& cit=m_config[m_nconfig];

	HANDLE h=FindFirstFile(cit.m_out_dir+"\\*.out",&fd);
	if (h!=INVALID_HANDLE_VALUE) {
		if (fd.nFileSizeLow==0) DeleteFile(cit.m_out_dir+"\\"+fd.cFileName);
		else {
			ProcessOutFile(fd.cFileName);		//  
		}
		for (; FindNextFile(h,&fd); ) {
			if (fd.nFileSizeLow==0) DeleteFile(cit.m_out_dir+"\\"+fd.cFileName);
			else {
				ProcessOutFile(fd.cFileName);	//  
			}
		}
		FindClose(h);
	}
}

void CTGWconfApp::ProcessOutFile(LPCSTR ffname)
{
	int t;
	CConfigItem& cit=m_config[m_nconfig];
	CStringArray * pArr;
	CStringArray tmp_arr;
	if (m_pStdp->GetStatus()!=CWinSTDP::WinSTDPStatus::CONN_OK) return;	//   

	CString fname;
	CString from_auto,to_auto;
	CString spooldir=cit.m_out_dir;

reopen:
	//        30 
	for (t=0; t<300; t++) {
		if (m_pStdp->GetOutQueueSize()<1) break;
		Sleep(100);
	}
	if (m_pStdp->GetOutQueueSize()>0) {
		Sleep(1000); ExitProcess(100);
	}

	//     
	TRY {
		CStdioFile f(spooldir+"\\"+ffname,CFile::shareExclusive);
		CString cs;
		for (; f.ReadString(cs); ) {
			cs.OemToAnsi();
			pArr=Synt(&tmp_arr,cs,"= \t,");
			if ((*pArr)[0]=="") fname=(*pArr)[1];
			if ((*pArr)[0]=="") {
				switch ((*pArr).GetSize()) {
				case 3: fname=(*pArr)[2]; break;
				case 2: fname=(*pArr)[1]; break;
				default: {
					CString cs;
					cs.Format("     %s\n"
						"     \n"
						"   .  !",
						spooldir+"\\"+ffname);
					Sleep(1000); ExitProcess(100);
						 }
				}
			}
			to_auto=cit.m_serv_aa;
			from_auto=cit.m_local_aa;
		}

		f.Close();
	} CATCH( CFileException, e ) {
		if (e->m_cause==CFileException::fileNotFound) goto fin;
		if (e->m_cause==CFileException::badPath) goto fin;
		if (e->m_cause==CFileException::generic) goto fin;
		if (e->m_cause==CFileException::tooManyOpenFiles) goto fin;
		if (e->m_cause==CFileException::hardIO) goto fin;
		Sleep(100); goto reopen;
	}
	END_CATCH

	TRY {
		CFile f(spooldir+"\\"+fname,CFile::shareExclusive);
			
		CString cs,csmail;
		char *p=cs.GetBuffer(MAX_STDP_ANSWER+1);
		int suc=f.Read(p,MAX_STDP_ANSWER); p[suc]=0;
		FuckingMainFrame(p);
		cs.ReleaseBuffer(); 
		cs.OemToAnsi(); cs.MakeUpper(); cs.AnsiToOem();
		f.Close();

		//    SMTP
		csmail=cs;
		
		//    STDP
		cs.OemToAnsi();
		if (!m_pStdp->PutMessage(cs)) {
			AddToLogList("FAILED TX: %s",(LPCSTR)cs.Left(150));
			goto fin;
		}

		//    SMTP
		while (!SendMail(m_nconfig,csmail,"<< "+cit.m_name)) Sleep(100);

		//       
		AddToLogList("TX: %s",(LPCSTR)cs.Left(150));

redelete1:
		TRY{
			CFile::Remove(spooldir+"\\"+fname);
		} CATCH( CFileException, e ) {
			if (e->m_cause==CFileException::fileNotFound) goto fin;
			if (e->m_cause==CFileException::badPath) goto fin;
			if (e->m_cause==CFileException::generic) goto fin;
			if (e->m_cause==CFileException::tooManyOpenFiles) goto fin;
			if (e->m_cause==CFileException::hardIO) goto fin;
			Sleep(100); goto redelete1;
		}
		END_CATCH

redelete2:
		TRY{
			CFile::Remove(spooldir+"\\"+ffname);
		} CATCH( CFileException, e ) {
			if (e->m_cause==CFileException::fileNotFound) goto fin;
			if (e->m_cause==CFileException::badPath) goto fin;
			if (e->m_cause==CFileException::generic) goto fin;
			if (e->m_cause==CFileException::tooManyOpenFiles) goto fin;
			if (e->m_cause==CFileException::hardIO) goto fin;
			Sleep(100); goto redelete2;
		}
		END_CATCH

	} CATCH(CFileException, e) {
		switch (e->m_cause) {
		case CFileException::none: break;
		case CFileException::generic: break;
		case CFileException::fileNotFound: break;
		case CFileException::badPath: break;
		case CFileException::tooManyOpenFiles: break;
		case CFileException::accessDenied: break;
		case CFileException::invalidFile: break;
		case CFileException::removeCurrentDir: break;
		case CFileException::directoryFull: break;
		case CFileException::badSeek: break;
		case CFileException::hardIO: break;
		case CFileException::sharingViolation: Sleep(100); goto reopen; break;
		case CFileException::lockViolation: Sleep(100); goto reopen; break;
		case CFileException::diskFull: break;
		case CFileException::endOfFile: break;
		default: ;
		}
	}
	END_CATCH
fin: ;
}

void CTGWconfApp::FuckingMainFrame(char *s)
{
	static const char * _lat = "ETYOPAHKXCBMeyopaxc";
	static const char * _rus = "";

	CString lat=_lat; lat.AnsiToOem();
	CString rus=_rus; rus.AnsiToOem();

	for (int i = 0; s[i]; i++) {
		for (int j=0; j<rus.GetLength(); j++) {
            if (s[i]==rus[j]) {s[i] = lat[j]; break;}
		}
	}
}

void CTGWconfApp::WaitAnsThread(CTGWconfApp &app)
{
	//        
	int counter=0;
	while (TRUE) {
		if (app.m_pStdp->HaveMessage()) {
			CString buf;
			CConfigItem& cit=app.m_config[app.m_nconfig];
			buf=app.m_pStdp->GetMessage();
			//   
			app.WriteInFile(buf);
			CString cs=buf; cs.AnsiToOem();
			while (!app.SendMail(app.m_nconfig,cs,">> "+cit.m_name)) {
				TRACE("         %d\n",app.m_nconfig);
				Sleep(100);
			}
		}

		//  
		counter++;
		if (counter>=30) {
			INDMSG ind;
			ind.Type=ind.Status;
			strcpy(ind.ConfName,app.m_config[app.m_nconfig].m_name.Left(MAX_CONFNAME));
			ind.STDP_Status=app.m_pStdp->GetStatus();

			COPYDATASTRUCT cps;
			cps.dwData=0;
			cps.cbData=sizeof(INDMSG);
			cps.lpData=&ind;

			CWnd *pWnd=CWnd::FindWindow(NULL,"TGW  ");
			if (pWnd) {
				pWnd->SendMessage(WM_COPYDATA,0,(LPARAM)&cps);
			} else ExitProcess(0);
			counter=0;
		}
		Sleep(10);
	}
}

void CTGWconfApp::WriteInFile(LPCSTR answer)
{
	CStringArray spd_arr;	//  *.spd 
	CStringArray pos_arr;	//  *.pos 
	HANDLE h;
	WIN32_FIND_DATA fd;

	CConfigItem& cit=m_config[m_nconfig];

	TRY {
		//     *.spd    (  )
		h=FindFirstFile(cit.m_in_dir+"\\*.spd",&fd);
		if (h!=INVALID_HANDLE_VALUE) {
			spd_arr.Add(fd.cFileName);
			for (; FindNextFile(h,&fd); ) spd_arr.Add(fd.cFileName);
			FindClose(h);
		}
		if (spd_arr.GetSize()<1) spd_arr.Add("00-00000.spd");

		//     *.pos    (  )
		h=FindFirstFile(cit.m_in_dir+"\\*.pos",&fd);
		if (h!=INVALID_HANDLE_VALUE) {
			pos_arr.Add(fd.cFileName);
			for (; FindNextFile(h,&fd); ) spd_arr.Add(fd.cFileName);
			FindClose(h);
		}
	} CATCH(CFileException, e) {
		CString err="   ";
	}
	END_CATCH

	if (pos_arr.GetSize()<1) pos_arr.Add("00-00000.pos");

	//    *.spd - 
	int n=1;
	CTime time=CTime::GetCurrentTime();
	if (time.GetDay()!=atoi(spd_arr[0])) n=1;
	else n=atoi(((LPCSTR)(spd_arr[0]))+3);

	//    *.txt  *,in - 
	CString txt_file; txt_file.Format("%02d-%05u.t_",time.GetDay(),n);
	CString in_file;  in_file.Format("%02d-%05u.i_",time.GetDay(),n);
	CString txt_file_res; txt_file_res.Format("%02d-%05u.txt",time.GetDay(),n);
	CString in_file_res;  in_file_res.Format("%02d-%05u.in",time.GetDay(),n);

	//  *.txt-
	TRY {
		CFile ft(cit.m_in_dir+"\\"+txt_file,CFile::modeWrite|CFile::modeCreate|CFile::shareExclusive);
		CString buf=answer; buf.AnsiToOem();
		ft.Write(buf,buf.GetLength());
		const char *s="***********************************************************:)\r\n";
		ft.Write(s,strlen(s));
		ft.Close();
		MoveFile(cit.m_in_dir+"\\"+txt_file,cit.m_in_dir+"\\"+txt_file_res);
	} CATCH(CFileException, e) {
		CString err;
		switch (e->m_cause) {
		case CFileException::none: break;
		case CFileException::generic: err="    "; break;
		case CFileException::fileNotFound: break;
		case CFileException::badPath: err=" .    "; break;
		case CFileException::tooManyOpenFiles: err="   .    "; break;
		case CFileException::accessDenied: err=" .    "; break;
		case CFileException::invalidFile: err=" .    "; break;
		case CFileException::removeCurrentDir: err="   .    "; break;
		case CFileException::directoryFull: err=" .    "; break;
		case CFileException::badSeek: break;
		case CFileException::hardIO: err=" .    "; break;
		case CFileException::sharingViolation: err=" .    "; break;
		case CFileException::lockViolation: err=" .    "; break;
		case CFileException::diskFull: err=" .    "; break;
		case CFileException::endOfFile: break;
		default: ;
		}
		Beep(3000,500);
		AfxMessageBox(err+" '"+txt_file+"'",MB_OK|MB_ICONWARNING);
		Sleep(1000); ExitProcess(255);
	}
	END_CATCH

	//    *.in  
	TRY {
		CStdioFile fi(cit.m_in_dir+"\\"+in_file_res,CFile::modeWrite|CFile::modeCreate|CFile::shareExclusive);
		CString cs;
		cs.Format("=1000,%s\n",txt_file_res); cs.AnsiToOem();
		fi.WriteString(cs);
		cs.Format("=%s\n",cit.m_local_aa); cs.AnsiToOem();
		fi.WriteString(cs);
		cs.Format("=%s\n",cit.m_serv_aa); cs.AnsiToOem();
		fi.WriteString(cs);
		cs.Format("=%s%05u.in\n",in_file.Left(3),n+1); cs.AnsiToOem();
		fi.WriteString(cs);
		fi.Close();
		MoveFile(cit.m_in_dir+"\\"+in_file,cit.m_in_dir+"\\"+in_file_res);
	} CATCH(CFileException, e) {
		CString err;
		switch (e->m_cause) {
		case CFileException::none: break;
		case CFileException::generic: err="    "; break;
		case CFileException::fileNotFound: break;
		case CFileException::badPath: err=" .    "; break;
		case CFileException::tooManyOpenFiles: err="   .    "; break;
		case CFileException::accessDenied: err=" .    "; break;
		case CFileException::invalidFile: err=" .    "; break;
		case CFileException::removeCurrentDir: err="   .    "; break;
		case CFileException::directoryFull: err=" .    "; break;
		case CFileException::badSeek: break;
		case CFileException::hardIO: err=" .    "; break;
		case CFileException::sharingViolation: err=" .    "; break;
		case CFileException::lockViolation: err=" .    "; break;
		case CFileException::diskFull: err=" .    "; break;
		case CFileException::endOfFile: break;
		default: ;
		}
		Beep(3000,500);
		AfxMessageBox(err+" '"+in_file+"'",MB_OK|MB_ICONWARNING);
		Sleep(1000); ExitProcess(100);
	}
	END_CATCH

	{
		//   spd-
		for (int i=0; i<spd_arr.GetSize(); i++) {
			if (atoi(spd_arr[i])>0)
				CFile::Remove(cit.m_in_dir+"\\"+spd_arr[i]);
		}
		//   spd-
		CString spd_new;
		spd_new.Format("%02d-%05u.spd",time.GetDay(),n+1);
		TRY {
			CFile fs(cit.m_in_dir+"\\"+spd_new,CFile::modeWrite|CFile::modeCreate|CFile::shareExclusive);
			fs.Close();
		} CATCH(CFileException, e) {
		}
		END_CATCH
}

	{
		//     *.in
		CStringArray in_arr;
		CString pos_new;
		h=FindFirstFile(cit.m_in_dir+"\\*.in",&fd);
		if (h!=INVALID_HANDLE_VALUE) {
			in_arr.Add(fd.cFileName);
			for (; FindNextFile(h,&fd); ) in_arr.Add(fd.cFileName);
			FindClose(h);
		}

		if (spd_arr.GetSize()<1) {
			pos_new.Format("%02d-%05u.pos",time.GetDay(),n+1);
			in_arr.Add(pos_new);
		} else {
			//     ()
			for (int i=0; i<in_arr.GetSize(); i++) {
				for (int j=i+1; j<in_arr.GetSize(); j++) {
					if (in_arr[i]>in_arr[j]) {
						pos_new=in_arr[i];
						in_arr[i]=in_arr[j];
						in_arr[j]=pos_new;
					}
				}
			}
		}

		//   pos-
		for (int i=0; i<pos_arr.GetSize(); i++) {
			if (atoi(pos_arr[i])>0) {
				TRY {
					CFile::Remove(cit.m_in_dir+"\\"+pos_arr[i]);
				} CATCH(CFileException, e) {
				}
				END_CATCH
			}
		}
		//   pos-
		n=atoi(((LPCSTR)(in_arr[0]))+3);
		pos_new.Format("%02d-%05u.pos",time.GetDay(),n);
		TRY {
			CFile fs(cit.m_in_dir+"\\"+pos_new,CFile::modeWrite|CFile::modeCreate|CFile::shareExclusive);
			fs.Close();
		} CATCH(CFileException, e) {
		}
		END_CATCH
	}

	//       
	AddToLogList("RX: %.150s",(LPCSTR)answer);
}

int CTGWconfApp::Run() 
{
	// TODO: Add your specialized code here and/or call the base class
	m_pStdp=new CSpoolSTDP;
	CConfigItem& cit=m_config[m_nconfig];
	m_pStdp->Connect(cit.m_serv_ip,atol(cit.m_serv_port),cit.m_serv_aa,cit.m_local_aa,m_nconfig);

	//      30 
	for (int i=0; i<300; i++) {
		if (m_pStdp->GetStatus()==CWinSTDP::CONN_OK) break;
		Sleep(100);
	}

	AfxBeginThread((AFX_THREADPROC)WaitAnsThread,this);

	if (m_pStdp->GetStatus()==CWinSTDP::CONN_OK) {
		while (TRUE) ProcessConf();
	}
	
	return CWinApp::Run();
}

void CTGWconfApp::AddToLogList(LPCSTR fmt, ... )
{
	if (m_nconfig>=0 && m_nconfig<(UINT)m_config.GetSize()) {
		CString cs;
		va_list marker;
		va_start(marker,fmt);
		cs.FormatV(fmt,marker);
		va_end(marker);

		INDMSG ind;
		ind.Type=ind.LogStr;
		strcpy(ind.ConfName,m_config[m_nconfig].m_name.Left(MAX_CONFNAME));
		strcpy(ind.buf,cs.Left(MAX_MESSAGE));

		COPYDATASTRUCT cps;
		cps.dwData=0;
		cps.cbData=sizeof(INDMSG);
		cps.lpData=&ind;

		CWnd *pWnd=CWnd::FindWindow(NULL,"TGW  ");
		if (pWnd) {
			pWnd->SendMessage(WM_COPYDATA,0,(LPARAM)&cps);
		}
	}
}

CString CTGWconfApp::GetFileExceptionText(CFileException &e)
{
	CString err="";
	switch (e.m_cause) {
	case CFileException::none: break;
	case CFileException::generic: err="    "; break;
	case CFileException::fileNotFound: break;
	case CFileException::badPath: err=" .    "; break;
	case CFileException::tooManyOpenFiles: err="   .    "; break;
	case CFileException::accessDenied: err=" .    "; break;
	case CFileException::invalidFile: err=" .    "; break;
	case CFileException::removeCurrentDir: err="   .    "; break;
	case CFileException::directoryFull: err=" .    "; break;
	case CFileException::badSeek: break;
	case CFileException::hardIO: err=" .    "; break;
	case CFileException::sharingViolation: err=" .    "; break;
	case CFileException::lockViolation: err=" .    "; break;
	case CFileException::diskFull: err=" .    "; break;
	case CFileException::endOfFile: break;
	default: ;
	}
	return err;
}
