// TGWmail.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TGWmail.h"
#include "TGWmailDlg.h"
#include "../TGW/SmtpSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTGWmailApp

BEGIN_MESSAGE_MAP(CTGWmailApp, CWinApp)
	//{{AFX_MSG_MAP(CTGWmailApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTGWmailApp construction

CTGWmailApp::CTGWmailApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_pSmtp=NULL;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTGWmailApp object

CTGWmailApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTGWmailApp initialization

BOOL CTGWmailApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED,MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
		return FALSE;
	}

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	if (__argc<2) {
		Beep(3000,100);
		AfxMessageBox(" TGWmail.exe   c !\n"
			"     TGW.exe",MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
		ExitProcess(0);
	}
	if (m_nconfig<0 || (int)m_nconfig>=m_config.GetSize()) {
		Beep(3000,100);
		AfxMessageBox(" TGWmail.exe    !\n"
			"     TGW.exe",MB_OK|MB_ICONWARNING|MB_SYSTEMMODAL);
		ExitProcess(0);
	}
	
	return TRUE;
}

int CTGWmailApp::Run() 
{
	// TODO: Add your specialized code here and/or call the base class
	SetThreadPriority(THREAD_PRIORITY_LOWEST);

	m_pSmtp=new CSmtpSocket;

	//     ,     1.5 
	//      ,   
	ReadSpool();
	//      

	delete m_pSmtp;

	return CWinApp::Run();
}

CString CTGWmailApp::GetStartDir()
{
	CString retv=__argv[0];
	int i=retv.ReverseFind('\\');
	if (i>=0) retv=retv.Left(i);
	else retv=".";
	return retv;
}



CString CTGWmailApp::GetMailSpoolDir()
{
	return GetStartDir()+"\\TGWmail";
}

void CTGWmailApp::ReadSpool()
{
	if (m_config.GetSize()<1) return;

	WIN32_FIND_DATA fd;
	HANDLE h=FindFirstFile(GetApp()->GetMailSpoolDir()+"\\*.tmp",&fd);
	if (h!=INVALID_HANDLE_VALUE) {

		//       
		m_pSmtp->Connect(m_config.m_email_srv, 25);
		//  10   
		for (int i=0; !m_pSmtp->IsConnected() && i<1000; i++) Sleep(20);
		if (!m_pSmtp->IsConnected()) ExitProcess(0);


		CString repl;
		BOOL suc=m_pSmtp->GetAnswer(repl);	//   
		if (!suc || atol(repl)!=220) ExitProcess(0);


		if (fd.nFileSizeLow==0) DeleteFile(GetApp()->GetMailSpoolDir()+"\\"+fd.cFileName);
		else ProcessMailFile(fd.cFileName);		//  
		for (; FindNextFile(h,&fd); ) {
			if (fd.nFileSizeLow==0) DeleteFile(GetApp()->GetMailSpoolDir()+"\\"+fd.cFileName);
			else ProcessMailFile(fd.cFileName);	//  
			if (!CWnd::FindWindow(NULL,"TGW  ")) ExitProcess(0);
		}
		FindClose(h);
		
		m_pSmtp->Disconnect();
	}
}

CString CTGWmailApp::GetCurrentVersion()
{
	return "6.0b";
}

void CTGWmailApp::ProcessMailFile(LPCSTR ffname)
{
	CString fname;
	CString server;
	UINT port;
	CString to;
	CString from="STDP_TGW";
	CString msg;
	CString subject;
	CString spooldir=GetApp()->GetMailSpoolDir();
	int nconf=-1;

reopen:
	//      
	TRY {
		CStdioFile f(spooldir+"\\"+ffname,CFile::modeRead|CFile::shareExclusive);
		CString cs;
		if (!f.ReadString(cs)) goto fin;
		if (!f.ReadString(cs)) goto fin;
		server=cs.Mid(strlen("SERVER="));
		if (!f.ReadString(cs)) goto fin;
		port=atol(cs.Mid(strlen("PORT=")));
		if (!f.ReadString(cs)) goto fin;
		to=cs.Mid(strlen("TO="));
		if (!f.ReadString(cs)) goto fin;
		from=cs.Mid(strlen("FROM="));
		if (!f.ReadString(cs)) goto fin;
		subject=cs.Mid(strlen("SUBJECT="));
		if (!f.ReadString(cs)) goto fin;
		if (cs.Left(17)=="# == TGW SIGNATURE") {
			f.Close();
			goto redelete;
		}
		while (f.ReadString(cs)) msg+=cs+"\n";
		f.Close();

		//    
		if (!SendMail(server,port,to,from,msg,subject)) goto fin;

	} CATCH( CFileException, e ) {
		if (e->m_cause==CFileException::fileNotFound) goto fin;
		if (e->m_cause==CFileException::badPath) goto fin;
		if (e->m_cause==CFileException::generic) goto fin;
		if (e->m_cause==CFileException::tooManyOpenFiles) goto fin;
		if (e->m_cause==CFileException::hardIO) goto fin;
		Sleep(100); goto reopen;
	}
	END_CATCH

redelete:
	TRY{
		CFile::Remove(spooldir+"\\"+ffname);
	} CATCH( CFileException, e ) {
		if (e->m_cause==CFileException::fileNotFound) goto fin;
		if (e->m_cause==CFileException::badPath) goto fin;
		if (e->m_cause==CFileException::generic) goto fin;
		if (e->m_cause==CFileException::tooManyOpenFiles) goto fin;
		if (e->m_cause==CFileException::hardIO) goto fin;
		Sleep(100); goto redelete;
	}
	END_CATCH
fin: ;
}

BOOL CTGWmailApp::SendMail(LPCSTR serv, UINT port, LPCSTR to, LPCSTR from, LPCSTR msg, LPCSTR subject)
{
	BOOL suc=FALSE;
	if (m_pSmtp->IsConnected()) {
		suc=m_pSmtp->SendMessage(to,from,msg,subject);
		if (suc) WriteToMailLog("SUCCESS server='%s' to='%s' msg='%.10s...'",serv,to,msg);
		else     WriteToMailLog("ERROR   server='%s' to='%s' msg='%.10s...'",serv,to,msg);
	} else       WriteToMailLog("ERROR:  CAN'T CONNECT TO server='%s' port=%d",serv,port);

	return suc;
}

void CTGWmailApp::WriteToMailLog(LPCSTR fmt, ...)
{
	va_list marker;

	va_start(marker,fmt);
	TRY {
		CStdioFile f(GetMailLogFileName(),
			CFile::modeWrite|CFile::modeCreate|CFile::shareDenyNone|CFile::modeNoTruncate);
		f.Seek(0L,CFile::end);
		CTime t=CTime::GetCurrentTime();
		CString cs;
		cs.FormatV(fmt,marker);

		char *p=cs.GetBuffer(1024);
		for (; p[0]; p++) {
			if (p[0]=='\r') p[0]=' ';
			if (p[0]=='\n') p[0]=' ';
			if (p[0]=='\t') p[0]=' ';
		}
		cs.ReleaseBuffer();
		
		f.WriteString(t.Format("%d/%m/%Y %H:%M:%S")+" - "+cs+"\n");
		f.Close();	
	} CATCH( CFileException, e ) {
	}
	END_CATCH
	va_end(marker);
}

CString CTGWmailApp::GetMailLogFileName()
{
	return GetStartDir()+"\\TGWMail.log";
}
